var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { ref, unref, computed, effectScope, inject, triggerRef, reactive, toRef, getCurrentInstance, provide, onUnmounted } from "vue";
import axios from "axios";
const Type = Function;
function isType(v) {
  return typeof v === "function";
}
var InjectFlags = /* @__PURE__ */ ((InjectFlags2) => {
  InjectFlags2[InjectFlags2["Default"] = 0] = "Default";
  InjectFlags2[InjectFlags2["Self"] = 1] = "Self";
  InjectFlags2[InjectFlags2["SkipSelf"] = 2] = "SkipSelf";
  InjectFlags2[InjectFlags2["Optional"] = 4] = "Optional";
  return InjectFlags2;
})(InjectFlags || {});
var OptionFlags = /* @__PURE__ */ ((OptionFlags2) => {
  OptionFlags2[OptionFlags2["Optional"] = 1] = "Optional";
  OptionFlags2[OptionFlags2["CheckSelf"] = 2] = "CheckSelf";
  OptionFlags2[OptionFlags2["CheckParent"] = 4] = "CheckParent";
  OptionFlags2[OptionFlags2["Default"] = 6] = "Default";
  return OptionFlags2;
})(OptionFlags || {});
const EMPTY = [];
const IDENT = function(value) {
  return value;
};
const CIRCULAR = IDENT;
const MULTI_PROVIDER_FN = function() {
  return Array.prototype.slice.call(arguments);
};
const NEW_LINE = /\n/gm;
const NO_NEW_LINE = "ɵ";
const _THROW_IF_NOT_FOUND = {};
const THROW_IF_NOT_FOUND = _THROW_IF_NOT_FOUND;
const NG_TEMP_TOKEN_PATH = "ngTempTokenPath";
function stringify(token) {
  if (typeof token === "string") {
    return token;
  }
  if (Array.isArray(token)) {
    return "[" + token.map(stringify).join(", ") + "]";
  }
  if (token == null) {
    return "" + token;
  }
  if (token.overriddenName) {
    return `${token.overriddenName}`;
  }
  if (token.name) {
    return `${token.name}`;
  }
  const res = token.toString();
  if (res == null) {
    return "" + res;
  }
  const newLineIndex = res.indexOf("\n");
  return newLineIndex === -1 ? res : res.substring(0, newLineIndex);
}
function getClosureSafeProperty(objWithPropertyToExtract) {
  for (const key in objWithPropertyToExtract) {
    if (objWithPropertyToExtract[key] === getClosureSafeProperty) {
      return key;
    }
  }
  throw Error("Could not find renamed property on target object.");
}
function formatError(text, obj, injectorErrorName, source = null) {
  text = text && text.charAt(0) === "\n" && text.charAt(1) == NO_NEW_LINE ? text.substr(2) : text;
  let context = stringify(obj);
  if (Array.isArray(obj)) {
    context = obj.map(stringify).join(" -> ");
  } else if (typeof obj === "object") {
    const parts = [];
    for (const key in obj) {
      if (obj.hasOwnProperty(key)) {
        const value = obj[key];
        parts.push(
          key + ":" + (typeof value === "string" ? JSON.stringify(value) : stringify(value))
        );
      }
    }
    context = `{${parts.join(", ")}}`;
  }
  return `${injectorErrorName}${source ? "(" + source + ")" : ""}[${context}]: ${text.replace(NEW_LINE, "\n  ")}`;
}
function staticError(text, obj) {
  return new Error(formatError(text, obj, "StaticInjectorError"));
}
function ɵɵdefineInjectable(opts) {
  return {
    token: opts.token,
    providedIn: opts.providedIn || null,
    factory: opts.factory,
    value: void 0
  };
}
const NG_PROV_DEF = getClosureSafeProperty({ ɵprov: getClosureSafeProperty });
getClosureSafeProperty({ ɵinj: getClosureSafeProperty });
const NG_INJECTABLE_DEF = getClosureSafeProperty({ ngInjectableDef: getClosureSafeProperty });
function getOwnDefinition(type, def) {
  return def && def.token === type ? def : null;
}
function getInjectableDef(type) {
  return getOwnDefinition(type, type[NG_PROV_DEF]) || getOwnDefinition(type, type[NG_INJECTABLE_DEF]);
}
class InjectionToken {
  constructor(_desc, options) {
    __publicField(this, "ngMetadataName", "InjectionToken");
    __publicField(this, "ɵprov");
    this._desc = _desc;
    this.ɵprov = void 0;
    if (typeof options === "number") {
      this.__NG_ELEMENT_ID__ = options;
    } else if (options !== void 0) {
      this.ɵprov = ɵɵdefineInjectable({
        token: this,
        providedIn: options.providedIn || "root",
        factory: options.factory
      });
    }
  }
  toString() {
    return `InjectionToken ${this._desc}`;
  }
}
function createInjectionToken(token) {
  return new InjectionToken(token);
}
class Injector {
}
class NullInjector {
  get(token, notFoundValue = THROW_IF_NOT_FOUND) {
    if (notFoundValue === THROW_IF_NOT_FOUND) {
      const error = new Error(`NullInjectorError: No provider for ${stringify(token)}!`);
      error.name = "NullInjectorError";
      throw error;
    }
    return notFoundValue;
  }
}
const NULL_INJECTOR = new NullInjector();
const __forward_ref__ = getClosureSafeProperty({ __forward_ref__: getClosureSafeProperty });
function resolveForwardRef(type) {
  return isForwardRef(type) ? type() : type;
}
function forwardRef(forwardRefFn) {
  forwardRefFn.__forward_ref__ = forwardRef;
  forwardRefFn.toString = function() {
    return stringify(this());
  };
  return forwardRefFn;
}
function isForwardRef(fn) {
  return typeof fn === "function" && fn.hasOwnProperty(__forward_ref__) && fn.__forward_ref__ === forwardRef;
}
const INJECTOR = new InjectionToken("INJECTOR", -1);
const USE_VALUE = getClosureSafeProperty({ provide: String, useValue: getClosureSafeProperty });
let _currentInjector = void 0;
function setCurrentInjector(injector) {
  const former = _currentInjector;
  _currentInjector = injector;
  return former;
}
class StaticInjector {
  constructor(providers, parent = NULL_INJECTOR, source = null) {
    __publicField(this, "parent");
    __publicField(this, "source");
    __publicField(this, "scope");
    __publicField(this, "_records");
    parent = parent ? parent : NULL_INJECTOR;
    this.parent = parent;
    this.source = source;
    const records = this._records = /* @__PURE__ */ new Map();
    records.set(Injector, { token: Injector, fn: IDENT, deps: EMPTY, value: this, useNew: false });
    records.set(INJECTOR, { token: INJECTOR, fn: IDENT, deps: EMPTY, value: this, useNew: false });
    this.scope = recursivelyProcessProviders(records, providers);
  }
  get(token, notFoundValue, flags = InjectFlags.Default) {
    const records = this._records;
    let record = records.get(token);
    if (record === void 0) {
      const injectableDef = getInjectableDef(token);
      if (injectableDef) {
        const providedIn = injectableDef && injectableDef.providedIn;
        if (providedIn === "any" || providedIn != null && providedIn === this.scope) {
          records.set(
            token,
            record = resolveProvider({ provide: token, useFactory: injectableDef.factory, deps: EMPTY })
          );
        }
      }
      if (record === void 0) {
        records.set(token, null);
      }
    }
    const lastInjector = setCurrentInjector(this);
    try {
      return tryResolveToken(token, record, records, this.parent, notFoundValue, flags);
    } catch (e) {
      throw e;
    } finally {
      setCurrentInjector(lastInjector);
    }
  }
  toString() {
    const tokens = [];
    const records = this._records;
    records.forEach((v, token) => tokens.push(stringify(token)));
    return `StaticInjector[${tokens.join(", ")}]`;
  }
}
function multiProviderMixError(token) {
  return staticError("Cannot mix multi providers and regular providers", token);
}
const INJECTOR_SCOPE = new InjectionToken("Set Injector scope.");
function recursivelyProcessProviders(records, provider) {
  let scope = null;
  if (provider) {
    provider = resolveForwardRef(provider);
    if (Array.isArray(provider)) {
      for (let i = 0; i < provider.length; i++) {
        scope = recursivelyProcessProviders(records, provider[i]) || scope;
      }
    } else if (typeof provider === "function") {
      throw staticError("Function/Class not supported", provider);
    } else if (provider && typeof provider === "object" && provider.provide) {
      let token = resolveForwardRef(provider.provide);
      const resolvedProvider = resolveProvider(provider);
      if (provider.multi === true) {
        let multiProvider = records.get(token);
        if (multiProvider) {
          if (multiProvider.fn !== MULTI_PROVIDER_FN) {
            throw multiProviderMixError(token);
          }
        } else {
          records.set(token, multiProvider = {
            token: provider.provide,
            deps: [],
            useNew: false,
            fn: MULTI_PROVIDER_FN,
            value: EMPTY
          });
        }
        token = provider;
        multiProvider.deps.push({ token, options: OptionFlags.Default });
      }
      const record = records.get(token);
      if (record && record.fn === MULTI_PROVIDER_FN) {
        throw multiProviderMixError(token);
      }
      if (token === INJECTOR_SCOPE) {
        scope = resolvedProvider.value;
      }
      records.set(token, resolvedProvider);
    } else {
      throw staticError("Unexpected provider", provider);
    }
  }
  return scope;
}
function resolveProvider(provider) {
  const deps = computeDeps(provider);
  let fn = IDENT;
  let value = EMPTY;
  let useNew = false;
  const provide2 = resolveForwardRef(provider.provide);
  if (USE_VALUE in provider) {
    value = provider.useValue;
  } else if (provider.useFactory) {
    fn = provider.useFactory;
  } else if (provider.useExisting)
    ;
  else if (provider.useClass) {
    useNew = true;
    fn = resolveForwardRef(provider.useClass);
  } else if (typeof provide2 === "function") {
    useNew = true;
    fn = provide2;
  } else {
    throw staticError(
      "StaticProvider does not have [useValue|useFactory|useExisting|useClass] or [provide] is not newable",
      provider
    );
  }
  return { deps, fn, useNew, value };
}
function computeDeps(provider) {
  let deps = EMPTY;
  const providerDeps = provider.deps;
  if (providerDeps && providerDeps.length) {
    deps = [];
    for (let i = 0; i < providerDeps.length; i++) {
      const options = OptionFlags.Default;
      const token = resolveForwardRef(providerDeps[i]);
      deps.push({ token, options });
    }
  } else if (provider.useExisting) {
    const token = resolveForwardRef(provider.useExisting);
    deps = [{ token, options: OptionFlags.Default }];
  } else if (!providerDeps && !(USE_VALUE in provider)) {
    throw staticError("'deps' required", provider);
  }
  return deps;
}
function tryResolveToken(token, record, records, parent, notFoundValue, flags) {
  try {
    return resolveToken(token, record, records, parent, notFoundValue, flags);
  } catch (e) {
    const path = e[NG_TEMP_TOKEN_PATH] = e[NG_TEMP_TOKEN_PATH] || [];
    path.unshift(token);
    if (record && record.value === CIRCULAR) {
      record.value = EMPTY;
    }
    throw e;
  }
}
function resolveToken(token, record, records, parent, notFoundValue, flags) {
  let value;
  if (record && !(flags & InjectFlags.SkipSelf)) {
    value = record.value;
    if (value === CIRCULAR) {
      throw Error(NO_NEW_LINE + "Circular dependency");
    } else if (value === EMPTY) {
      record.value = CIRCULAR;
      const useNew = record.useNew;
      const fn = record.fn;
      const depRecords = record.deps;
      let deps = EMPTY;
      if (depRecords.length) {
        deps = [];
        for (let i = 0; i < depRecords.length; i++) {
          const depRecord = depRecords[i];
          const options = depRecord.options;
          const childRecord = options & OptionFlags.CheckSelf ? records.get(depRecord.token) : void 0;
          deps.push(
            tryResolveToken(
              depRecord.token,
              childRecord,
              records,
              !childRecord && !(options & OptionFlags.CheckParent) ? NULL_INJECTOR : parent,
              options & OptionFlags.Optional ? null : THROW_IF_NOT_FOUND,
              InjectFlags.Default
            )
          );
        }
      }
      record.value = value = useNew ? new fn(...deps) : fn.apply(void 0, deps);
    }
  } else if (!(flags & InjectFlags.Self)) {
    value = parent.get(token, notFoundValue, InjectFlags.Default);
  } else if (!(flags & InjectFlags.Optional)) {
    value = NULL_INJECTOR.get(token, notFoundValue);
  } else {
    value = NULL_INJECTOR.get(token, typeof notFoundValue !== "undefined" ? notFoundValue : null);
  }
  return value;
}
function INJECTOR_IMPL__PRE_R3__(providers, parent, name) {
  return new StaticInjector(providers, parent, name);
}
const INJECTOR_IMPL = INJECTOR_IMPL__PRE_R3__;
function createInjector(options, parent) {
  if (Array.isArray(options)) {
    return INJECTOR_IMPL(options, parent, "");
  } else {
    return INJECTOR_IMPL(options.providers, options.parent, options.name || "");
  }
}
const ANNOTATIONS = "__annotations__";
const PROP_METADATA = "__prop__metadata__";
function makeMetaCtor(metaFactory) {
  return function ctor(...args) {
    if (metaFactory) {
      const values = metaFactory(...args);
      for (const propName in values) {
        this[propName] = values[propName];
      }
    }
  };
}
function makeTypeMetadataDecorator(name, props, parentClass, chainFn, typeFn) {
  const metaCtor = makeMetaCtor(props);
  function DecoratorFactory(...args) {
    if (this instanceof DecoratorFactory) {
      metaCtor.call(this, ...args);
      return this;
    }
    const annotationInstance = new DecoratorFactory(...args);
    const typeDecorator = function createTypeDecorator(cls) {
      typeFn && typeFn(cls, ...args);
      const annotations = cls.hasOwnProperty(ANNOTATIONS) ? cls[ANNOTATIONS] : Object.defineProperty(cls, ANNOTATIONS, { value: [] })[ANNOTATIONS];
      annotations.push(annotationInstance);
      return cls;
    };
    if (chainFn) {
      chainFn(typeDecorator);
    }
    return typeDecorator;
  }
  if (parentClass) {
    DecoratorFactory.prototype = Object.create(parentClass.prototype);
  }
  DecoratorFactory.prototype.ngMetadataName = name;
  DecoratorFactory.annotationCls = DecoratorFactory;
  return DecoratorFactory;
}
function getAllPropMetas(target) {
  const constructor = target.constructor;
  let allPropMetas = null;
  if (constructor.hasOwnProperty(PROP_METADATA)) {
    allPropMetas = constructor[PROP_METADATA];
  } else {
    allPropMetas = Object.defineProperty(constructor, PROP_METADATA, { value: {} })[PROP_METADATA];
  }
  return allPropMetas;
}
function getSinglePropMetas(target, propName) {
  const allPropMetas = getAllPropMetas(target);
  if (allPropMetas.hasOwnProperty(propName)) {
    return allPropMetas[propName];
  }
  return [];
}
function makePropMetadataDecorator(name, metaFactory, parentClass) {
  const metaCtor = makeMetaCtor(metaFactory);
  function PropDecoratorFactory(...args) {
    if (this instanceof PropDecoratorFactory) {
      metaCtor.apply(this, args);
      return this;
    }
    const decoratorInstance = new PropDecoratorFactory(...args);
    function PropDecorator(target, propName) {
      const allPropMetas = getAllPropMetas(target);
      allPropMetas[propName] = getSinglePropMetas(target, propName);
      allPropMetas[propName].unshift(decoratorInstance);
    }
    return PropDecorator;
  }
  if (parentClass) {
    PropDecoratorFactory.prototype = Object.create(parentClass.prototype);
  }
  PropDecoratorFactory.prototype.metadataName = name;
  PropDecoratorFactory.annotationClass = PropDecoratorFactory;
  return PropDecoratorFactory;
}
class PropMetadataReader {
  /**
   * 获取所有属性的所有类型元数据
   */
  static getPropsMetas(constructor) {
    const propsMetas = constructor[PROP_METADATA];
    if (!propsMetas) {
      return {};
    }
    return propsMetas;
  }
  /**
   * 获取所有属性某一类型的元数据
   */
  static getPropsMetasByName(constructor, metaName) {
    const propsMetas = this.getPropsMetas(constructor);
    if (!propsMetas) {
      return {};
    }
    const sameNamePropsMetas = {};
    Object.keys(propsMetas).forEach((propName) => {
      const propMetas = propsMetas[propName];
      const targetPropMeta = propMetas.find((propMeta) => {
        return propMeta.metadataName === metaName;
      });
      if (!targetPropMeta) {
        return;
      }
      sameNamePropsMetas[propName] = targetPropMeta;
    });
    return sameNamePropsMetas;
  }
}
class Effect {
  /**
   * 副作用构造器
   * @param effectFunction 副作用方法
   */
  constructor(effectFunction) {
    /**
     * 副作用方法
     */
    __publicField(this, "internalFunction");
    this.effectFunction = effectFunction;
    this.internalFunction = this.effectFunction;
  }
  /**
   * 执行副作用
   * @param change 变更 
   */
  run(change) {
    this.internalFunction(change);
  }
}
class EffectManager {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * 副作用集合
     */
    __publicField(this, "innerEffects", []);
  }
  /**
   * 添加副作用
   */
  addEffect(effect) {
    if (this.innerEffects.indexOf(effect) > -1) {
      return;
    }
    this.innerEffects.push(effect);
  }
  /**
   * 删除副作用
   */
  removeEffect(effect) {
    this.innerEffects = this.innerEffects.filter((internalEffect) => effect !== internalEffect);
  }
  /**
   * 获取全部副作用
   */
  getEffects() {
    return this.innerEffects;
  }
  /**
   * 执行全部副作用
   */
  trigger(change) {
    this.innerEffects.forEach((effect) => {
      effect.run(change);
    });
  }
}
const _Token = class _Token {
  static create(redix) {
    const timestamp = Date.now().valueOf();
    let uuid = 0;
    if (timestamp > _Token.previous) {
      _Token.previous = timestamp;
      uuid = timestamp;
    } else {
      _Token.previous = _Token.previous + 100;
      uuid = _Token.previous;
    }
    return uuid.toString(redix);
  }
};
__publicField(_Token, "previous", 0);
let Token = _Token;
const EXCEPTION_HANDLER_TOKEN = new InjectionToken("@farris/exception_handler_token");
const STATE_PROP_META_NAME = "STATE";
const stateMetaFactory = (meta) => {
  return meta;
};
const State = makePropMetadataDecorator(STATE_PROP_META_NAME, stateMetaFactory);
const GETTER_PROP_META_NAME = "GETTER";
const getterMetaFactory = (meta) => {
  return meta;
};
const Getter = makePropMetadataDecorator(GETTER_PROP_META_NAME, getterMetaFactory);
const ACTION_PROP_META_NAME = "ACTION";
const actionMetaFactory = (meta) => {
  return meta;
};
const Action = makePropMetadataDecorator(ACTION_PROP_META_NAME, actionMetaFactory);
const COMMAND_ACTION_PROP_META_NAME = "COMMAND_ACTION";
const commandActionMetaFactory = (meta) => {
  return meta;
};
const CommandAction = makePropMetadataDecorator(COMMAND_ACTION_PROP_META_NAME, commandActionMetaFactory);
class PropWrapper {
  /**
   * 构造函数
   */
  constructor(viewModel, propName, propMeta, scope) {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 属性名车给你
     */
    __publicField(this, "propName");
    /**
     * 属性元数据
     */
    __publicField(this, "propMeta");
    /**
     * 副作用上下文
     */
    __publicField(this, "scope");
    this.viewModel = viewModel;
    this.propName = propName;
    this.propMeta = propMeta;
    this.scope = scope;
  }
}
class StatePropWrapper extends PropWrapper {
  /**
   * 构造函数
   */
  constructor(viewModel, propName, propMeta, scope) {
    super(viewModel, propName, propMeta, scope);
  }
  /**
   * 包装属性
   * @summary
   * 将状态属性包装为ref，并自动解包
   */
  wrap() {
    const viewModel = this.viewModel;
    const initValue = viewModel[this.propName];
    function createAccessor() {
      const valueRef = ref(initValue);
      const accessor = {
        get() {
          return unref(valueRef);
        },
        set(value) {
          valueRef.value = value;
        }
      };
      return accessor;
    }
    let cachedAccessor = null;
    function getCachedAccessor() {
      if (!cachedAccessor) {
        cachedAccessor = createAccessor();
      }
      return cachedAccessor;
    }
    Object.defineProperty(viewModel, this.propName, {
      enumerable: true,
      configurable: true,
      get() {
        const accessor = getCachedAccessor();
        return accessor.get();
      },
      set(value) {
        const accessor = getCachedAccessor();
        accessor.set(value);
      }
    });
  }
  /**
   * 注销
   */
  dispose() {
  }
}
class GetterPropWrapper extends PropWrapper {
  /**
   * 构造函数
   */
  constructor(viewModel, propName, propMeta, scope) {
    super(viewModel, propName, propMeta, scope);
  }
  /**
   * 包装属性
   * @summary
   * 将get方法包装成计算属性
   */
  wrap() {
    const viewModel = this.viewModel;
    const viewModelPrototype = viewModel.constructor.prototype;
    const getterPropDescriptor = Object.getOwnPropertyDescriptor(viewModelPrototype, this.propName);
    if (!getterPropDescriptor || !getterPropDescriptor.get) {
      return;
    }
    const getter = getterPropDescriptor.get;
    const computedGetter = this.scope.run(() => {
      return computed(() => {
        return getter.call(viewModel);
      });
    });
    Object.defineProperty(viewModel, this.propName, {
      enumerable: true,
      configurable: true,
      get() {
        return computedGetter;
      }
    });
  }
  /**
   * 注销
   */
  dispose() {
  }
}
class ActionPropWrapper extends PropWrapper {
  /**
   * 构造函数
   */
  constructor(viewModel, propName, propMeta, scope) {
    super(viewModel, propName, propMeta, scope);
  }
  /**
   * 包装属性
   * @summary
   * 对原始动作进行包装，跟踪方法的执行过程
   */
  wrap() {
    const viewModel = this.viewModel;
    const viewModelPrototype = viewModel.constructor.prototype;
    const actionPropDescriptor = Object.getOwnPropertyDescriptor(viewModelPrototype, this.propName);
    if (!actionPropDescriptor || !actionPropDescriptor.value) {
      return;
    }
    const action = actionPropDescriptor.value;
    const wrappedAction = this.wrapAction(action);
    Object.defineProperty(viewModel, this.propName, {
      enumerable: true,
      configurable: true,
      get() {
        return wrappedAction;
      }
    });
  }
  /**
   * 包装动作
   */
  wrapAction(action) {
    const viewModel = this.viewModel;
    const wrappedAction = function() {
      const args = Array.from(arguments);
      return action.call(viewModel, ...args);
    };
    return wrappedAction;
  }
  /**
   * 注销
   */
  dispose() {
  }
}
class CommandActionPropWrapper extends ActionPropWrapper {
  /**
   * 构造函数
   */
  constructor(viewModel, propName, propMeta, scope) {
    super(viewModel, propName, propMeta, scope);
  }
  /**
   * 包装属性
   * @summary
   * 对原始动作进行包装，跟踪方法的执行过程
   */
  wrap() {
    const viewModel = this.viewModel;
    const propMeta = this.propMeta;
    const commandAction = function(eventParams) {
      const command = {
        name: propMeta.name,
        params: { ...propMeta.params },
        eventParams: eventParams ? JSON.parse(JSON.stringify(eventParams)) : null
      };
      return viewModel.dispatch(command);
    };
    const wrappedAction = this.wrapAction(commandAction);
    Object.defineProperty(viewModel, this.propName, {
      enumerable: true,
      configurable: true,
      get() {
        return wrappedAction;
      }
    });
  }
  /**
   * 注销
   */
  dispose() {
  }
}
class PropWrapperFactory {
  /**
   * 创建属性包装器
   */
  create(viewModel, propName, propMeta, scope) {
    let wrapper;
    switch (propMeta.metadataName) {
      case STATE_PROP_META_NAME:
        wrapper = new StatePropWrapper(viewModel, propName, propMeta, scope);
        break;
      case GETTER_PROP_META_NAME:
        wrapper = new GetterPropWrapper(viewModel, propName, propMeta, scope);
        break;
      case ACTION_PROP_META_NAME:
        wrapper = new ActionPropWrapper(viewModel, propName, propMeta, scope);
        break;
      case COMMAND_ACTION_PROP_META_NAME:
        wrapper = new CommandActionPropWrapper(viewModel, propName, propMeta, scope);
        break;
      default:
        throw new Error(`No PropWrapper for ${propMeta.metadataName}`);
    }
    return wrapper;
  }
}
const PRIMITIVE_FIELD_META_NAME = "PRIMITIVE_FIELD";
const primitiveFieldMetaFactory = (meta) => {
  return meta;
};
const Field = makePropMetadataDecorator(PRIMITIVE_FIELD_META_NAME, primitiveFieldMetaFactory);
const ENTITY_FIELD_META_NAME = "ENTITY_FIELD";
const entityFieldMetaFactory = (meta) => {
  return meta;
};
const EntityField = makePropMetadataDecorator(ENTITY_FIELD_META_NAME, entityFieldMetaFactory);
const ENTITY_LIST_FIELD_META_NAME = "ENTITY_LIST_FIELD";
const entitylistFieldMetaFactory = (meta) => {
  return meta;
};
const EntityListField = makePropMetadataDecorator(ENTITY_LIST_FIELD_META_NAME, entitylistFieldMetaFactory);
var FieldType = /* @__PURE__ */ ((FieldType2) => {
  FieldType2["Primitive"] = "Primitive";
  FieldType2["Entity"] = "Entity";
  FieldType2["EntityList"] = "EntityArray";
  return FieldType2;
})(FieldType || {});
var EntityPathNodeType = /* @__PURE__ */ ((EntityPathNodeType2) => {
  EntityPathNodeType2["IdValue"] = "IdValue";
  EntityPathNodeType2["PropName"] = "PropName";
  return EntityPathNodeType2;
})(EntityPathNodeType || {});
class EntityPathNode {
  /**
   * 构造函数
   */
  constructor(nodeType, nodeValue) {
    /**
     * 类型
     */
    __publicField(this, "nodeType");
    /**
     * 节点值
     */
    __publicField(this, "nodeValue");
    /**
     * 上一路径节点
     */
    __publicField(this, "prevNode");
    /**
     * 下一路径节点
     */
    __publicField(this, "nextNode");
    this.nodeType = nodeType;
    this.nodeValue = nodeValue;
  }
  /**
   * 获取节点类型
   */
  getNodeType() {
    return this.nodeType;
  }
  /**
   * 获取节点值
   */
  getNodeValue() {
    return this.nodeValue;
  }
  /**
   * 设置节点值
   */
  setNodeValue(nodeValue) {
    this.nodeValue = nodeValue;
  }
  /**
   * 获取上一节点
   */
  getPrevNode() {
    return this.prevNode;
  }
  /**
   * 获取下一节点
   */
  getNextNode() {
    return this.nextNode;
  }
  /**
   * 设置上一节点
   */
  setPrevNode(prevNode) {
    this.prevNode = prevNode;
  }
  /**
   * 设置下一节点
   */
  setNextNode(nextNode) {
    this.nextNode = nextNode;
  }
}
class EntityPath {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * 路径节点集合
     */
    __publicField(this, "nodes");
    this.nodes = [];
  }
  /**
   * 获取路径节点
   */
  getNodes() {
    return this.nodes;
  }
  /**
   * 获取第一个节点
   */
  getFirstNode() {
    return this.nodes[0];
  }
  /**
   * 获取最后一个节点
   */
  getLastNode() {
    return this.nodes[this.nodes.length - 1];
  }
  /**
   * 获取父实体路径
   */
  getParentEntityPath() {
    const parentEntityPath = new EntityPath();
    const parentPathNodes = this.nodes.concat([]);
    parentPathNodes.pop();
    parentPathNodes.forEach((parentPathNode) => {
      parentEntityPath.appendNode(parentPathNode);
    });
    return parentEntityPath;
  }
  /**
   * 添加节点
   */
  appendNode(node) {
    const prevNode = this.nodes.length === 0 ? null : this.nodes[0];
    if (prevNode) {
      prevNode.setNextNode(node);
    }
    node.setPrevNode(prevNode);
    this.nodes.push(node);
  }
  /**
   * 是否和当前路径相等
   */
  isSame(entityPath) {
    const targetNodes = entityPath.getNodes();
    if (this.nodes.length !== targetNodes.length) {
      return false;
    }
    const isDifferent = this.nodes.some((node, index) => {
      const targetNode = targetNodes[index];
      const isDifferentType = node.getNodeType() !== targetNode.getNodeType();
      const isDifferentValue = node.getNodeValue() !== targetNode.getNodeValue();
      if (isDifferentType || isDifferentValue) {
        return true;
      }
    });
    return !isDifferent;
  }
  /**
   * 是否为当前路径的祖先路径
   */
  isAncestor(ancestorPath) {
    const ancestorNodes = ancestorPath.getNodes();
    const descendantNodes = this.nodes;
    if (ancestorNodes.length >= descendantNodes.length) {
      return false;
    }
    const isDifferent = ancestorNodes.some((ancestorNode, index) => {
      const descendantNode = descendantNodes[index];
      const isDifferentType = ancestorNode.getNodeValue() !== descendantNode.getNodeType();
      const isDifferentValue = ancestorNode.getNodeValue() !== descendantNode.getNodeValue();
      if (isDifferentType || isDifferentValue) {
        return true;
      }
    });
    return !isDifferent;
  }
  /**
   * 是否为当前路径的父路径
   */
  isParent(parentPath) {
    const ancestorNodes = parentPath.getNodes();
    const descendantNodes = this.nodes;
    if (ancestorNodes.length !== descendantNodes.length - 1) {
      return false;
    }
    return this.isAncestor(parentPath);
  }
  /**
   * 克隆路径
   */
  clone() {
    const clonedEntityPath = new EntityPath();
    this.nodes.forEach((node) => {
      const type = node.getNodeType();
      const value = node.getNodeValue();
      const clonedNode = new EntityPathNode(type, value);
      clonedEntityPath.appendNode(clonedNode);
    });
    return clonedEntityPath;
  }
  /**
   * 转换为短路径
   * @returns 
   */
  toShortPath() {
    return "/" + this.nodes.filter((node) => node.getNodeType() === EntityPathNodeType.PropName).join("/");
  }
}
class EntityPathBuilder {
  /**
   * 构造函数
   */
  constructor(entityState) {
    /**
     * 实体状态
     */
    __publicField(this, "entityState");
    this.entityState = entityState;
  }
  /**
   * 构造实体路径
   */
  build(path, isEntityListPath = false) {
    if (path instanceof EntityPath) {
      return path;
    }
    this.checkPath(path);
    const entityList = this.entityState.getEntityList();
    const pathArray = this.convertToPathArray(path);
    const longPathArray = this.convertToLongPath(pathArray, entityList, isEntityListPath);
    const entityPath = this.buildEntityPath(longPathArray);
    return entityPath;
  }
  /**
   * 根据长路径数组构造实体路径对象
   */
  buildEntityPath(longPathArray) {
    const entityPath = new EntityPath();
    longPathArray.forEach((pathItem) => {
      const isIdPathItem = this.isIdPathItem(pathItem);
      const nodeType = isIdPathItem ? EntityPathNodeType.IdValue : EntityPathNodeType.PropName;
      let nodeValue;
      if (isIdPathItem) {
        nodeValue = pathItem.slice(1).slice(0, -1);
      } else {
        nodeValue = pathItem;
      }
      const pathNode = new EntityPathNode(nodeType, nodeValue);
      entityPath.appendNode(pathNode);
    });
    return entityPath;
  }
  /**
   * 转换为长路径
   * 短路径：/childs/grands/assoInfo/name
   * 长路径：/[id]/childs/[childId]/assoInfo/name
   */
  convertToLongPath(pathArray, entityList, isEntityListPath = false) {
    if (this.isShortPath(pathArray) === false) {
      return pathArray;
    }
    const pathArrayLen = pathArray.length;
    const longPathArray = [];
    if (isEntityListPath && pathArray.length === 0) {
      return longPathArray;
    }
    let currentEntity = entityList.getCurrentEntity();
    const currentId = currentEntity.idValue;
    longPathArray.push(`[${currentId}]`);
    pathArray.forEach((pathItem, pathIndex) => {
      const entitySchema = currentEntity.getSchema();
      const fieldSchema = entitySchema.getFieldSchemaByName(pathItem);
      if (!fieldSchema) {
        throw new Error(`${pathItem} not exist`);
      }
      if (fieldSchema.type === FieldType.EntityList) {
        const childEntityList = currentEntity[pathItem];
        const currentChildEntity = childEntityList.getCurrentEntity();
        longPathArray.push(pathItem);
        if (isEntityListPath && pathIndex === pathArrayLen - 1) {
          return;
        }
        longPathArray.push(`[${currentChildEntity.idValue}]`);
        currentEntity = currentChildEntity;
      } else if (fieldSchema.type === FieldType.Entity) {
        longPathArray.push(pathItem);
        currentEntity = currentEntity[pathItem];
      } else {
        longPathArray.push(pathItem);
      }
    });
    return longPathArray;
  }
  /**
   * 转换为路径数据
   */
  convertToPathArray(path) {
    if (Array.isArray(path)) {
      return path;
    }
    const pathArray = path.split("/").filter((pathItem) => {
      return pathItem;
    });
    return pathArray;
  }
  /**
   * 检查路径是否合法
   */
  checkPath(path) {
    if (!path) {
      throw new Error("path can not be empty");
    }
    if (Array.isArray(path) === true) {
      return;
    }
    if (typeof path !== "string") {
      throw new Error("path must be an string or array");
    }
    if (path.startsWith("/") === false) {
      throw new Error("path must be starts with /");
    }
  }
  /**
   * 检查是否为长路径
   */
  isShortPath(pathArray) {
    const firstPathItem = pathArray[0];
    if (firstPathItem && firstPathItem.startsWith("[")) {
      return false;
    }
    return true;
  }
  /**
   * 检查是否为ID路径片段
   */
  isIdPathItem(pathItem) {
    return pathItem.startsWith("[");
  }
}
class EntitySchema {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * 字段描述集合
     */
    __publicField(this, "fieldSchemaMap");
    /**
     * 主键值
     */
    __publicField(this, "idKey");
    this.fieldSchemaMap = /* @__PURE__ */ new Map();
  }
  /**
   * 获取全部字段描述
   */
  getFieldSchemas() {
    const fieldSchemas = Array.from(this.fieldSchemaMap.values());
    return fieldSchemas;
  }
  /**
   * 根据字段Type获取字段描述
   */
  getFieldSchemasByType(type) {
    const fieldSchemas = this.getFieldSchemas();
    const targetFieldSchemas = fieldSchemas.filter((fieldSchema) => {
      return fieldSchema.type === type;
    });
    return targetFieldSchemas;
  }
  /**
   * 根据字段Name获取字段描述
   */
  getFieldSchemaByName(name) {
    if (!this.fieldSchemaMap.has(name)) {
      return;
    }
    const targetFieldSchema = this.fieldSchemaMap.get(name);
    return targetFieldSchema;
  }
  /**
   * 根据字段Path获取字段描述
   */
  getFieldSchemaByPath(entityPath) {
    const entityPathNodes = entityPath.getNodes();
    let currentEntitySchema = this;
    let currentFieldSchema;
    entityPathNodes.forEach((entityPathNode) => {
      const pathNodeType = entityPathNode.getNodeType();
      const pathNodeValue = entityPathNode.getNodeValue();
      if (pathNodeType === EntityPathNodeType.IdValue) {
        return;
      }
      currentFieldSchema = currentEntitySchema.getFieldSchemaByName(pathNodeValue);
      if (currentFieldSchema.type === FieldType.Entity) {
        currentEntitySchema = currentFieldSchema.entitySchema;
      } else if (currentFieldSchema.type === FieldType.EntityList) {
        currentEntitySchema = currentFieldSchema.entitySchema;
      }
    });
    return currentFieldSchema;
  }
  /**
   * 添加字段信息
   */
  addFieldSchema(fieldSchema) {
    this.fieldSchemaMap.set(fieldSchema.name, fieldSchema);
  }
  /**
   * 设置主键字段
   */
  setIdKey(primaryKey) {
    this.idKey = primaryKey;
  }
  /**
   * 获取主键字段
   */
  getIdKey() {
    return this.idKey;
  }
}
class EntitySchemaCreator {
  /**
   * 构造函数
   */
  constructor(entityType) {
    /**
     * 实体类型
     */
    __publicField(this, "entityType");
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    this.entityType = entityType;
    this.entitySchema = new EntitySchema();
  }
  /**
   * 创建实体描述
   */
  create() {
    this.addFieldSchemas();
    return this.entitySchema;
  }
  /**
   * 添加实体
   */
  addFieldSchemas() {
    this.addPrimitiveFieldSchemas();
    this.addEntityFieldSchemas();
    this.addEntityListFieldSchemas();
  }
  /**
   * 添加简单字段描述
   */
  addPrimitiveFieldSchemas() {
    const fieldMetas = PropMetadataReader.getPropsMetasByName(this.entityType, PRIMITIVE_FIELD_META_NAME);
    Object.keys(fieldMetas).map((propName) => {
      const fieldMeta = fieldMetas[propName];
      const fieldSchema = {
        type: FieldType.Primitive,
        name: propName
      };
      this.entitySchema.addFieldSchema(fieldSchema);
      if (fieldMeta.primary === true) {
        this.entitySchema.setIdKey(propName);
      }
    });
  }
  /**
   * 添加实体字段描述
   */
  addEntityFieldSchemas() {
    const fieldMetas = PropMetadataReader.getPropsMetasByName(this.entityType, ENTITY_FIELD_META_NAME);
    Object.keys(fieldMetas).map((propName) => {
      const fieldMeta = fieldMetas[propName];
      const fieldSchema = {
        type: FieldType.Entity,
        name: propName,
        entitySchema: createEntitySchema(fieldMeta.entityType)
      };
      this.entitySchema.addFieldSchema(fieldSchema);
    });
  }
  /**
   * 添加实体列表字段描述
   */
  addEntityListFieldSchemas() {
    const fieldMetas = PropMetadataReader.getPropsMetasByName(this.entityType, ENTITY_LIST_FIELD_META_NAME);
    Object.keys(fieldMetas).map((propName) => {
      const fieldMeta = fieldMetas[propName];
      const fieldSchema = {
        type: FieldType.EntityList,
        name: propName,
        entitySchema: createEntitySchema(fieldMeta.entityType)
      };
      this.entitySchema.addFieldSchema(fieldSchema);
    });
  }
}
function createEntitySchema(entityType) {
  const schemaCreator = new EntitySchemaCreator(entityType);
  const schema = schemaCreator.create();
  return schema;
}
class EntityNode {
  constructor() {
    /**
     * 父节点
     */
    __publicField(this, "parentEntityNode");
  }
  /**
   * 设置父实体节点
   */
  setParentEntityNode(parentEntityNode) {
    this.parentEntityNode = parentEntityNode;
  }
  /**
   * 获取父实体节点
   */
  getParentEntityNode() {
    return this.parentEntityNode;
  }
}
function createEntity(entityType, entityData) {
  if (!entityType) {
    throw new Error(`The entityType parameter can't be empty`);
  }
  if (!entityData) {
    throw new Error(`The entityData parameter should be an array`);
  }
  const entitySchema = createEntitySchema(entityType);
  const entity = createEntityBySchema(entitySchema, entityData);
  return entity;
}
function createEntityBySchema(entitySchema, entityData) {
  if (!entitySchema) {
    throw new Error(`The entitySchema parameter can't be empty`);
  }
  if (!entityData) {
    throw new Error(`The entityData parameter should be an array`);
  }
  const entity = new Entity(entitySchema);
  entity.loadData(entityData);
  return entity;
}
function createEntities(entityType, entityDatas) {
  if (!entityType) {
    throw new Error(`The entityType parameter can't be empty`);
  }
  if (!Array.isArray(entityDatas)) {
    throw new Error(`The entityDatas parameter should be an array`);
  }
  const entitySchema = createEntitySchema(entityType);
  const entities = createEntitiesBySchema(entitySchema, entityDatas);
  return entities;
}
function createEntitiesBySchema(entitySchema, entityDatas) {
  if (!entitySchema) {
    throw new Error(`The entitySchema parameter can't be empty`);
  }
  if (!Array.isArray(entityDatas)) {
    throw new Error(`The entityDatas parameter should be an array`);
  }
  const entities = entityDatas.map((entityData) => {
    const entity = createEntityBySchema(entitySchema, entityData);
    return entity;
  });
  return entities;
}
class EntityList extends EntityNode {
  /**
   * 构造函数
   */
  constructor(entitySchema) {
    super();
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    /**
     * 实体集合
     */
    __publicField(this, "entities");
    /**
     * 当前实体ID
     */
    __publicField(this, "currentId");
    this.entitySchema = entitySchema;
    this.entities = [];
  }
  /**
   * 加载数据
   */
  loadData(entityDatas) {
    if (!Array.isArray(entityDatas)) {
      throw new Error("The entityDatas parameter should be an array");
    }
    const entities = createEntitiesBySchema(this.entitySchema, entityDatas);
    this.loadEntities(entities);
  }
  /**
   * 加载实体
   */
  loadEntities(entities) {
    this.entities = [];
    entities.forEach((entity) => {
      this.appendEntity(entity);
    });
    if (entities.length === 0) {
      this.currentId = null;
    } else {
      const firstEntity = this.entities[0];
      this.setCurrentId(firstEntity.idValue);
    }
  }
  /**
   * 批量追加实体
   */
  appendEntities(entities) {
    if (Array.isArray(entities) !== true) {
      return;
    }
    entities.forEach((entity) => {
      entity.setParentEntityNode(entity);
      this.entities.push(entity);
    });
    if (this.entities.length > 0) {
      const lastEntity = this.entities[this.entities.length - 1];
      this.setCurrentId(lastEntity.idValue);
    }
  }
  /**
   * 追加实体
   */
  appendEntity(entity) {
    entity.setParentEntityNode(entity);
    this.entities.push(entity);
    if (this.entities.length > 0) {
      const lastEntity = this.entities[this.entities.length - 1];
      this.setCurrentId(lastEntity.idValue);
    }
  }
  /**
   * 获取全部实体
   */
  getEntities() {
    return this.entities;
  }
  /**
   * 获取当前实体
   */
  getCurrentEntity() {
    if (!this.currentId) {
      return this.createEmpltyEntity();
    }
    const currentEntity = this.getEntityById(this.currentId);
    if (!currentEntity) {
      return this.createEmpltyEntity();
    }
    return currentEntity;
  }
  /**
   * 获取实体
   */
  setCurrentId(id) {
    const currentEntity = this.entities.find((entity) => {
      return entity.idValue === id;
    });
    if (!currentEntity) {
      this.currentId = null;
      return;
    }
    this.currentId = currentEntity.idValue;
  }
  /**
   * 获取实体
   */
  getEntityById(id) {
    const targetEntity = this.entities.find((entity) => {
      return entity.idValue === id;
    });
    return targetEntity;
  }
  /**
   * 删除实体
   */
  removeEntityById(id) {
    const targetIndex = this.entities.findIndex((entity) => {
      return entity.idValue === id;
    });
    if (targetIndex === -1) {
      return;
    }
    const currentEntity = this.getCurrentEntity();
    if (currentEntity.idValue === id) {
      let newCurrentIndex = null;
      if (targetIndex === this.entities.length - 1) {
        newCurrentIndex = targetIndex - 1;
      } else {
        newCurrentIndex = targetIndex + 1;
      }
      const newCurrentEntity = this.entities[newCurrentIndex];
      if (newCurrentEntity) {
        this.setCurrentId(newCurrentEntity.idValue);
      } else {
        this.setCurrentId(null);
      }
    }
    this.entities.splice(targetIndex, 1);
  }
  /**
   * 批量删除实体
   */
  removeEntityByIds(ids) {
    if (!Array.isArray(ids)) {
      return;
    }
    ids.forEach((id) => {
      this.removeEntityById(id);
    });
  }
  /**
   * 转换为JSON对象
   */
  toJSON() {
    const entityListData = this.entities.map((entity) => {
      return entity.toJSON();
    });
    return entityListData;
  }
  /**
   * 创建空实体
   */
  createEmpltyEntity() {
    const emptyEntity = createEntityBySchema(this.entitySchema, {});
    return emptyEntity;
  }
}
function createEntityList(entityType, entityDatas) {
  if (!entityType) {
    throw new Error(`The entityType parameter can't be empty`);
  }
  if (!Array.isArray(entityDatas)) {
    throw new Error(`The entityDatas parameter should be an array`);
  }
  const entitySchema = createEntitySchema(entityType);
  const entityList = createEntityListBySchema(entitySchema, entityDatas);
  return entityList;
}
function createEntityListBySchema(entitySchema, entityDatas) {
  if (!entitySchema) {
    throw new Error(`The entitySchema parameter can't be empty`);
  }
  if (!Array.isArray(entityDatas)) {
    throw new Error(`The entityDatas parameter should be an array`);
  }
  const entityList = new EntityList(entitySchema);
  entityList.loadData(entityDatas);
  return entityList;
}
class EntityDataLoader {
  /**
   * 构造函数
   */
  constructor(entity) {
    /**
     * 实体
     */
    __publicField(this, "entity");
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    this.entity = entity;
    this.entitySchema = entity.getSchema();
  }
  /**
   * 加载数据
   */
  load(entityData) {
    this.loadPrimitiveFields(entityData);
    this.loadEntityFields(entityData);
    this.loadEntityListFields(entityData);
  }
  /**
   * 加载简单字段数据
   */
  loadPrimitiveFields(entityData) {
    const entity = this.entity;
    const fieldSchemas = this.entitySchema.getFieldSchemasByType(FieldType.Primitive);
    fieldSchemas.forEach((fieldSchema) => {
      const propName = fieldSchema.name;
      entity[propName] = entityData[propName];
    });
  }
  /**
   * 加载实体字段数据
   */
  loadEntityFields(entityData) {
    const entity = this.entity;
    const fieldSchemas = this.entitySchema.getFieldSchemasByType(FieldType.Entity);
    fieldSchemas.forEach((fieldSchema) => {
      const propName = fieldSchema.name;
      const childEntitySchema = fieldSchema.entitySchema;
      const childEntityData = entityData[propName] || {};
      const childEntity = createEntityBySchema(childEntitySchema, childEntityData);
      childEntity.setParentEntityNode(entity);
      entity[propName] = childEntity;
    });
  }
  /**
   * 加载实体列表字段数据
   */
  loadEntityListFields(entityData) {
    const entity = this.entity;
    const fieldSchemas = this.entitySchema.getFieldSchemasByType(FieldType.EntityList);
    fieldSchemas.forEach((fieldSchema) => {
      const propName = fieldSchema.name;
      const childEntitySchema = fieldSchema.entitySchema;
      const childEntityListData = entityData[propName] || [];
      const childEntityList = createEntityListBySchema(childEntitySchema, childEntityListData);
      childEntityList.setParentEntityNode(entity);
      entity[propName] = childEntityList;
    });
  }
}
class EntityDataPeeker {
  /**
   * 构造函数
   */
  constructor(entity) {
    /**
     * 实体
     */
    __publicField(this, "entity");
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    this.entity = entity;
    this.entitySchema = entity.getSchema();
  }
  /**
   * 提取数据
   */
  peek() {
    const entityData = {};
    this.peekPrimitiveFields(entityData);
    this.peekEntityFields(entityData);
    this.peekEntityListFields(entityData);
    return entityData;
  }
  /**
   * 提取简单字段数据
   */
  peekPrimitiveFields(entityData) {
    const entity = this.entity;
    const fieldSchemas = this.entitySchema.getFieldSchemasByType(FieldType.Primitive);
    fieldSchemas.forEach((fieldSchema) => {
      const propName = fieldSchema.name;
      entityData[propName] = entity[propName];
    });
  }
  /**
   * 提取实体字段数据
   */
  peekEntityFields(entityData) {
    const entity = this.entity;
    const fieldSchemas = this.entitySchema.getFieldSchemasByType(FieldType.Entity);
    fieldSchemas.forEach((fieldSchema) => {
      const propName = fieldSchema.name;
      const childEntity = entity[propName];
      const childEntityData = childEntity ? childEntity.toJSON() : {};
      entityData[propName] = childEntityData;
    });
  }
  /**
   * 提取实体列表字段数据
   */
  peekEntityListFields(entityData) {
    const entity = this.entity;
    const fieldSchemas = this.entitySchema.getFieldSchemasByType(FieldType.EntityList);
    fieldSchemas.forEach((fieldSchema) => {
      const propName = fieldSchema.name;
      const childEntityList = entity[propName];
      const childEntityListData = childEntityList ? childEntityList.toJSON() : [];
      entityData[propName] = childEntityListData;
    });
  }
}
class Entity extends EntityNode {
  /**
   * 构造函数
   */
  constructor(schema) {
    super();
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    /**
     * 数据加载器
     */
    __publicField(this, "entityDataLoader");
    /**
     * 数据提取器
     */
    __publicField(this, "entityDataPeeker");
    this.entitySchema = schema;
    this.entityDataLoader = new EntityDataLoader(this);
    this.entityDataPeeker = new EntityDataPeeker(this);
  }
  /**
   * 主键
   */
  get idKey() {
    return this.entitySchema.getIdKey();
  }
  /**
   * 主键值
   */
  get idValue() {
    return this[this.idKey];
  }
  /**
   * 获取实体描述
   */
  getSchema() {
    return this.entitySchema;
  }
  /**
   * 加载数据
   */
  loadData(data) {
    this.entityDataLoader.load(data);
  }
  /**
   * 转换为JSON对象
   */
  toJSON() {
    const data = this.entityDataPeeker.peek();
    return data;
  }
}
var EntityChangeType = /* @__PURE__ */ ((EntityChangeType2) => {
  EntityChangeType2["Load"] = "Load";
  EntityChangeType2["Append"] = "Append";
  EntityChangeType2["Remove"] = "Remove";
  EntityChangeType2["Update"] = "Update";
  EntityChangeType2["ValueChange"] = "ValueChange";
  EntityChangeType2["CurrentChange"] = "CurrentChange";
  return EntityChangeType2;
})(EntityChangeType || {});
var EntityChangeStatus = /* @__PURE__ */ ((EntityChangeStatus2) => {
  EntityChangeStatus2["New"] = "New";
  EntityChangeStatus2["Staged"] = "Staged";
  EntityChangeStatus2["Committed"] = "Commited";
  EntityChangeStatus2["Canceled"] = "Canceled";
  return EntityChangeStatus2;
})(EntityChangeStatus || {});
class EntityChangeMerger {
  /**
   * 构造函数
   */
  constructor(changes) {
    /**
     * 合并前的变更
     */
    __publicField(this, "changes");
    /**
     * 合并后的变更
     */
    __publicField(this, "mergedChagnes");
    this.changes = changes;
    this.mergedChagnes = [];
  }
  /**
   * 合并变更
   */
  mergeChanges() {
    this.changes.forEach((change) => {
      this.mergeChange(change);
    });
    return this.mergedChagnes;
  }
  mergeChange(change) {
    if (change.status !== EntityChangeStatus.New) {
      return;
    }
    const clonedChange = Object.assign({}, change);
    switch (clonedChange.type) {
      case EntityChangeType.ValueChange:
        this.mergeChangeValueChange(change);
        break;
      case EntityChangeType.Update:
        this.mergeUpdateChange(change);
        break;
      case EntityChangeType.Remove:
        this.mergeRemoveChange(change);
        break;
    }
  }
  /**
   * 合并值变更
   */
  mergeChangeValueChange(change) {
    const existedMergedChange = this.mergedChagnes.find((mergedChange) => {
      const isSameType = mergedChange.type === EntityChangeType.ValueChange;
      const isSamePath = mergedChange.path.isSame(change.path);
      if (isSameType && isSamePath) {
        return true;
      }
      return false;
    });
    if (existedMergedChange) {
      existedMergedChange.newValue = change.newValue;
    } else {
      this.mergedChagnes.push(change);
    }
  }
  /**
   * 合并更新变更
   */
  mergeUpdateChange(change) {
    Object.keys(change.newEntityData).forEach((propName) => {
      const changeValueChange = this.convertToChangeValueChange(change, propName);
      this.mergeChangeValueChange(changeValueChange);
    });
  }
  /**
   * 合并删除变更
   */
  mergeRemoveChange(change) {
    this.mergedChagnes = this.mergedChagnes.filter((mergedChange) => {
      return mergedChange.path.isAncestor(change.path) === false;
    });
  }
  /**
   * 转换为值变更
   */
  convertToChangeValueChange(change, propName) {
    const oldValue = change.oldEntityData[propName];
    const newValue = change.newEntityData[propName];
    const path = change.path.clone();
    path.appendNode(new EntityPathNode(EntityPathNodeType.PropName, propName));
    const changeValueChange = {
      type: EntityChangeType.ValueChange,
      path,
      oldValue,
      newValue,
      status: change.status,
      snapshot: change.snapshot
    };
    return changeValueChange;
  }
}
class EntityChangeHistory {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * 变更集合
     */
    __publicField(this, "changes");
    this.changes = [];
  }
  /**
   * 获取全部变更
   */
  getChanges() {
    return this.changes;
  }
  /**
   * 获取合并
   */
  getMergedChanges() {
    const merger = new EntityChangeMerger(this.changes);
    const mergedChanges = merger.mergeChanges();
    return mergedChanges;
  }
  /**
   * 添加变更
   */
  addChange(change) {
    change.status = EntityChangeStatus.New;
    this.changes.push(change);
  }
  /**
   * 暂存变更
   */
  stageChanges() {
    this.changes.forEach((change) => {
      if (change.status === EntityChangeStatus.New) {
        change.status = EntityChangeStatus.Staged;
      }
    });
  }
  /**
   * 提交变更
   */
  commitChanges() {
    this.changes.forEach((change) => {
      if (change.status === EntityChangeStatus.New || change.status === EntityChangeStatus.Staged) {
        change.status = EntityChangeStatus.Committed;
      }
    });
  }
  /**
   * 取消变更
   */
  cancelChanges() {
    this.changes.forEach((change) => {
      if (change.status === EntityChangeStatus.New || change.status === EntityChangeStatus.Staged) {
        change.status = EntityChangeStatus.Canceled;
      }
    });
  }
}
class EntityStateQuery {
  /**
   * 构造函数
   */
  constructor(entityState) {
    /**
     * 实体类型
     */
    __publicField(this, "entityState");
    /**
     * 实体集合
     */
    __publicField(this, "entityList");
    this.entityState = entityState;
    this.entityList = entityState.getEntityList();
  }
  /**
   * 获取实体数组
   */
  getEntities() {
    return this.entityList.getEntities();
  }
  /**
   * 根据Path获取实体数组
   */
  getEntitiesByPath(path) {
    const entityList = this.getEntityNode(path);
    const entities = entityList.getEntities();
    return entities;
  }
  /**
   * 获取实体列表
   */
  getEntityList() {
    return this.entityList;
  }
  /**
   * 根据Path获取实体列表
   */
  getEntityListByPath(path) {
    const entityList = this.getEntityNode(path);
    return entityList;
  }
  /**
   * 根据ID获取根实体
   */
  getEntityById(id) {
    const entity = this.entityList.getEntityById(id);
    return entity;
  }
  /**
   * 根据Path获取实体
   */
  getEntityByPath(path) {
    const entity = this.getEntityNode(path);
    if (!entity) {
      return;
    }
    return entity;
  }
  /**
   * 获取根当前实体
   */
  getCurrentEntity() {
    const currentEntity = this.entityList.getCurrentEntity();
    return currentEntity;
  }
  /**
   * 根据Path获取当前实体
   */
  getCurrentEntityByPath(path) {
    const entityList = this.getEntityListByPath(path);
    const currentEntity = entityList.getCurrentEntity();
    return currentEntity;
  }
  /**
   * 根据字段名获取根实体字段值
   */
  getValue(name) {
    const currentEntity = this.getCurrentEntity();
    return currentEntity[name];
  }
  /**
   * 根据路径获取字段值
   */
  getValueByPath(path) {
    const value = this.getEntityNode(path);
    return value;
  }
  /**
   * 根据路径获取实体、实体集合、属性值
   */
  getEntityNode(path) {
    const entityPathNodes = path.getNodes();
    let currentEntityNode = this.entityList;
    entityPathNodes.forEach((entityPathNode) => {
      const pathNodeType = entityPathNode.getNodeType();
      const pathNodeValue = entityPathNode.getNodeValue();
      if (pathNodeType === EntityPathNodeType.IdValue) {
        currentEntityNode = currentEntityNode.getEntityById(pathNodeValue) || currentEntityNode.getCurrentEntity();
      } else {
        currentEntityNode = currentEntityNode[pathNodeValue];
      }
    });
    return currentEntityNode;
  }
}
class EntityStateUpdater {
  /**
   * 构造函数
   */
  constructor(entityState) {
    /**
     * 实体类型
     */
    __publicField(this, "entityState");
    /**
     * 实体集合
     */
    __publicField(this, "entityList");
    /**
     * 实体查询器
     */
    __publicField(this, "entityQuery");
    this.entityState = entityState;
    this.entityList = entityState.getEntityList();
    this.entityQuery = entityState.entityQuery;
  }
  /**
   * 根据path加载实体集合
   */
  loadEntitesByPath(path, entities) {
    const entityList = this.entityQuery.getEntityListByPath(path);
    entityList.loadEntities(entities);
    const pagination = this.entityState.getPaginationByPath(path);
    const change = {
      type: EntityChangeType.Load,
      path,
      entities,
      pagination
    };
    this.entityState.triggerChanges(change);
  }
  /**
   * 根据path追加实体集合
   */
  appendEntitesByPath(path, entities) {
    const entityList = this.entityQuery.getEntityListByPath(path);
    entityList.appendEntities(entities);
    const change = {
      type: EntityChangeType.Append,
      path,
      entities
    };
    this.entityState.triggerChanges(change);
  }
  /**
   * 根据Path批量删除实体
   */
  removeEntitiesByPath(path, ids) {
    const entityList = this.entityQuery.getEntityListByPath(path);
    const entities = entityList.getEntities();
    const entitiesToRemove = entities.filter((entity) => {
      return ids.includes(entity.idValue);
    });
    entityList.removeEntityByIds(ids);
    const change = {
      type: EntityChangeType.Remove,
      path,
      entities: entitiesToRemove
    };
    this.entityState.triggerChanges(change);
  }
  /**
   * 根据实体path，更新实体
   */
  updateEntityByPath(path, newValues) {
    const entity = this.entityQuery.getEntityByPath(path);
    if (!entity) {
      return;
    }
    const changedOldValues = {};
    const changedNewValues = {};
    Object.keys(newValues).forEach((propName) => {
      const oldValue = entity[propName];
      const newValue = newValues[propName];
      if (oldValue !== newValue) {
        changedOldValues[propName] = oldValue;
        changedNewValues[propName] = newValue;
        entity[propName] = newValue;
      }
    });
    const change = {
      type: EntityChangeType.Update,
      path,
      oldEntityData: changedOldValues,
      newEntityData: changedNewValues
    };
    this.entityState.triggerChanges(change);
  }
  /**
   * 根据属性Path，更新属性值
   */
  setValueByPath(path, newValue) {
    const parentPath = path.getParentEntityPath();
    const entity = this.entityQuery.getEntityByPath(parentPath);
    const fieldPathNode = path.getLastNode();
    const fieldName = fieldPathNode.getNodeValue();
    const oldValue = entity[fieldName];
    if (oldValue === newValue) {
      return;
    }
    entity[fieldName] = newValue;
    const change = {
      type: EntityChangeType.ValueChange,
      path,
      oldValue,
      newValue
    };
    this.entityState.triggerChanges(change);
  }
  /**
   * 根据Paht和ID改变当前实体
   */
  changeCurrentEntityByPath(path, id) {
    const entityList = this.entityQuery.getEntityListByPath(path);
    const newCurrentEntity = entityList.getEntityById(id);
    if (!newCurrentEntity) {
      return;
    }
    const oldCurrentEntity = this.entityQuery.getCurrentEntityByPath(path);
    if (oldCurrentEntity === newCurrentEntity) {
      return;
    }
    entityList.setCurrentId(id);
    const change = {
      type: EntityChangeType.CurrentChange,
      path,
      oldCurrentEntity,
      newCurrentEntity
    };
    this.entityState.triggerChanges(change);
  }
}
class EntityState {
  /**
   * 构造函数
   */
  constructor(entityType) {
    /**
     * 副作用管理器
     */
    __publicField(this, "effectManager");
    __publicField(this, "entityPagination");
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    /**
     * 根实体列表
     */
    __publicField(this, "entityList");
    /**
     * 实体类型
     */
    __publicField(this, "entityType");
    /**
     * 实体状态查询器
     */
    __publicField(this, "entityQuery");
    /**
     * 实体更新器
     */
    __publicField(this, "entityUpdater");
    /**
     * 变更历史记录
     */
    __publicField(this, "entityChangeHistory");
    this.effectManager = new EffectManager();
    this.entityType = entityType;
    this.entitySchema = createEntitySchema(this.entityType);
    this.entityList = createEntityList(this.entityType, []);
    this.entityQuery = new EntityStateQuery(this);
    this.entityUpdater = new EntityStateUpdater(this);
    this.entityChangeHistory = new EntityChangeHistory();
  }
  /**
   * 获取实体列表
   */
  getEntityList() {
    return this.entityList;
  }
  /**
   * 根据path获取实体列表
   */
  getEntityListByPath(path) {
    const entityPath = this.createPath(path, true);
    return this.entityQuery.getEntityListByPath(entityPath);
  }
  /**
   * 获取根实体集合
   */
  getEntities() {
    return this.entityList.getEntities();
  }
  /**
   * 根据Path获取根实体集合
   */
  getEntitiesByPath(path) {
    const entityPath = this.createPath(path, true);
    return this.entityQuery.getEntitiesByPath(entityPath);
  }
  /**
   * 根据ID获取根实体
   */
  getEntityById(id) {
    return this.entityQuery.getEntityById(id);
  }
  /**
   * 根据Path获取实体
   */
  getEntityByPath(path) {
    const entityPath = this.createPath(path);
    return this.entityQuery.getEntityByPath(entityPath);
  }
  /**
   * 根据Path获取字段值
   */
  getValueByPath(path) {
    const entityPath = this.createPath(path);
    return this.entityQuery.getValueByPath(entityPath);
  }
  /**
   * 根据ID获取根实体
   */
  getCurrentEntity() {
    return this.entityQuery.getCurrentEntity();
  }
  /**
   * 根据Path获取实体
   */
  getCurrentEntityByPath(path) {
    const entityPath = this.createPath(path);
    return this.entityQuery.getCurrentEntityByPath(entityPath);
  }
  /**
   * 加载根实体集合
   */
  loadEntities(entities) {
    const entityPath = this.createPath("/", true);
    this.entityUpdater.loadEntitesByPath(entityPath, entities);
  }
  /**
   * 根据Path加载实体集合
   */
  loadEntitesByPath(path, entities) {
    const entityPath = this.createPath(path, true);
    this.entityUpdater.loadEntitesByPath(entityPath, entities);
  }
  /**
   * 加载根实体集合
   */
  appendEntities(entities) {
    const entityPath = this.createPath("/", true);
    this.entityUpdater.appendEntitesByPath(entityPath, entities);
  }
  /**
   * 根据Path加载实体集合
   */
  appendEntitesByPath(path, entities) {
    const entityPath = this.createPath(path, true);
    this.entityUpdater.appendEntitesByPath(entityPath, entities);
  }
  /**
   * 根据ID删除根实体
   */
  removeEntityById(id) {
    const entityPath = this.createPath("/", true);
    this.entityUpdater.removeEntitiesByPath(entityPath, [id]);
  }
  /**
   * 根据父Paht和ID删除实体
   */
  removeEntityByPath(path, id) {
    const entityPath = this.createPath(path, true);
    this.entityUpdater.removeEntitiesByPath(entityPath, [id]);
  }
  /**
   * 根据ID批量删除根实体
   */
  removeEntitiesByIds(ids) {
    const entityPath = this.createPath("/", true);
    this.entityUpdater.removeEntitiesByPath(entityPath, ids);
  }
  /**
   * 根据path和ID批量删除实体
   */
  removeEntitiesByPath(path, ids) {
    const entityPath = this.createPath(path, true);
    this.entityUpdater.removeEntitiesByPath(entityPath, ids);
  }
  /**
   * 根据ID更新实体
   */
  updateEntityById(id, values) {
    const entityPath = this.createPath(`/[${id}]`);
    this.entityUpdater.updateEntityByPath(entityPath, values);
  }
  /**
   * 根据Path更新实体
   */
  updateEntityByPath(path, values) {
    const entityPath = this.createPath(path);
    this.entityUpdater.setValueByPath(entityPath, values);
  }
  /**
   * 根据path更新字段值
   */
  setValueByPath(path, value) {
    const entityPath = this.createPath(path);
    this.entityUpdater.setValueByPath(entityPath, value);
  }
  /**
   * 设置当前根实体
   */
  changeCurrentEntityById(id) {
    const entityListPath = this.createPath("/", true);
    this.entityUpdater.changeCurrentEntityByPath(entityListPath, id);
  }
  /**
   * 根据Path设置当前实体
   */
  changeCurrentEntityByPath(path, id) {
    const enityListPath = this.createPath(path, true);
    this.entityUpdater.changeCurrentEntityByPath(enityListPath, id);
  }
  /**
   * 构造实体路径
   */
  createPath(path, isEntityListPath = false) {
    const entityPathCreator = new EntityPathBuilder(this);
    const entityPath = entityPathCreator.build(path, isEntityListPath);
    return entityPath;
  }
  /**
   * 触发变更
   */
  triggerChanges(change) {
    this.effectManager.trigger(change);
    this.entityChangeHistory.addChange(change);
  }
  /**
   * 监听变更
   */
  watchChanges(changeEffectFunc) {
    const changeEffect = new Effect(changeEffectFunc);
    this.effectManager.addEffect(changeEffect);
    const stopWatch = () => {
      this.effectManager.removeEffect(changeEffect);
    };
    return stopWatch;
  }
  /**
   * 获取实体类型
   */
  getEntityType() {
    return this.entityType;
  }
  /**
   * 获取实体结构描述
   */
  getEntitySchema() {
    return this.entitySchema;
  }
  /**
   * 更新实体分页配置
   * @param entityPagination 
   */
  setEntityPagination(entityPagination) {
    this.entityPagination = entityPagination;
  }
  /**
   * 获取实体分页配置
   * @returns 
   */
  getEntityPagination() {
    return this.entityPagination;
  }
  /**
   * 更新指定实体分页信息
   * @param path 
   * @param pagination 
   */
  setPaginationByPath(path, pagination) {
    if (Array.isArray(path)) {
      path = `/${path.join("/")}`;
    } else if (path instanceof EntityPath) {
      path = path.toShortPath();
    }
    const previousPagination = this.getPaginationByPath(path);
    this.entityPagination[path] = Object.assign({}, previousPagination, pagination);
  }
  getPaginationByPath(path) {
    if (Array.isArray(path)) {
      path = `/${path.join("/")}`;
    } else if (path instanceof EntityPath) {
      path = path.toShortPath();
    }
    return this.entityPagination && this.entityPagination[path];
  }
  /**
   * 转换为JSON
   */
  toJSON() {
    const entityStateJson = {
      entityList: this.entityList.toJSON(),
      currentEntity: this.entityList.getCurrentEntity().toJSON()
    };
    return entityStateJson;
  }
}
const UISTATE_PROP_META_NAME = "UISTATE_PROP_META";
const uiStatePropMetaFactory = (meta) => {
  return meta;
};
const UIStateProp = makePropMetadataDecorator(UISTATE_PROP_META_NAME, uiStatePropMetaFactory);
var UIStateChangeType = /* @__PURE__ */ ((UIStateChangeType2) => {
  UIStateChangeType2["ValueChange"] = "ValueChange";
  return UIStateChangeType2;
})(UIStateChangeType || {});
class UIState {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * 变更副作用管理器
     */
    __publicField(this, "effectManager");
    this.effectManager = new EffectManager();
  }
  /**
   * 根据名称获取状态值
   */
  getValue(name) {
    return this[name];
  }
  /**
   * 根据路径获取状态值
   */
  getValueByPath(path) {
    this.checkPath(path);
    const pathSegments = path.split("/").slice(1);
    const value = pathSegments.reduce((currentValue, pathSegment) => {
      if (!currentValue) {
        throw new Error(`Can not read property of empty object( reading ${pathSegment})`);
      }
      return currentValue[pathSegment];
    }, this);
    return value;
  }
  /**
   * 检查路径合法性
   */
  checkPath(path) {
    if (!path || typeof path !== "string") {
      throw new Error("The path must be a non-empty string.");
    }
    if (path.startsWith("/") === false) {
      throw new Error("The path must be started with slash.");
    }
    if (path.startsWith("/") === false) {
      throw new Error("The path must not be ended with slash.");
    }
    if (path.length < 1) {
      throw new Error("It must contain at least one character other than a slash");
    }
    const pathItems = path.split("/").slice(1);
    if (!pathItems) {
      throw new Error("The path must be a non-empty string.");
    }
    const emptyPathItemIndex = pathItems.findIndex((pathItem) => {
      return !pathItem;
    });
    if (emptyPathItemIndex > -1) {
      throw new Error("The path can not contain empty segment ");
    }
  }
  /**
   * 设置属性值
   */
  setValue(name, newValue) {
    const oldValue = this[name];
    if (oldValue === newValue) {
      return;
    }
    this[name] = newValue;
    const change = {
      type: UIStateChangeType.ValueChange,
      path: name,
      oldValue,
      newValue
    };
    this.triggerChange(change);
  }
  /**
   * 触发变更
   */
  triggerChange(change) {
    this.effectManager.trigger(change);
  }
  /**
   * 监听变更
   */
  watchChange(changeEffectFunc) {
    const changeEffect = new Effect(changeEffectFunc);
    this.effectManager.addEffect(changeEffect);
    const stopWatch = () => {
      this.effectManager.removeEffect(changeEffect);
    };
    return stopWatch;
  }
}
var BindingType = /* @__PURE__ */ ((BindingType2) => {
  BindingType2["EntityState"] = "EntityState";
  BindingType2["UIState"] = "UIState";
  return BindingType2;
})(BindingType || {});
const CONTROL_PROP_META_NAME = "CONTROL";
const controlMetaFactory = (meta) => {
  return meta;
};
const ControlProp = makePropMetadataDecorator(CONTROL_PROP_META_NAME, controlMetaFactory);
class EntityStateValueAccessor {
  /**
   * 构造函数
   */
  constructor(entityState, bindingPath) {
    /**
     * 实体状态
     */
    __publicField(this, "entityState");
    /**
     * 绑定路径
     */
    __publicField(this, "bindingPath");
    this.entityState = entityState;
    this.bindingPath = bindingPath;
  }
  /**
   * 从数据源获取值
   */
  getValue() {
    const value = this.entityState.getValueByPath(this.bindingPath);
    return value;
  }
  /**
   * 向数据源赋值
   */
  setValue(controlValue) {
    this.entityState.setValueByPath(this.bindingPath, controlValue);
  }
}
class UIStateValueAccessor {
  /**
   * 构造函数
   */
  constructor(uiState, path) {
  }
  /**
   * 从数据源获取值
   */
  getValue() {
    throw new Error("Not Implemented");
  }
  /**
   * 从数据源设置值
   */
  setValue(controlValue) {
    throw new Error("Not Implemented");
  }
}
class ValueAccessorFactory {
  /**
   * 构造函数
   */
  constructor(viewModel) {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    this.viewModel = viewModel;
  }
  /**
   * 创建值访问器
   */
  create(controlConfig) {
    const { bindingType, bindingPath } = controlConfig;
    switch (bindingType) {
      case BindingType.EntityState: {
        const { entityState } = this.viewModel;
        if (!entityState) {
          throw Error("EntityState not exist");
        }
        return new EntityStateValueAccessor(entityState, bindingPath);
      }
      case BindingType.UIState: {
        const { uiState } = this.viewModel;
        if (!uiState) {
          throw Error("UIState not exist");
        }
        return new UIStateValueAccessor(uiState, bindingPath);
      }
      default:
        throw new Error(`${bindingType} not supported`);
    }
  }
}
class FormControl {
  /**
   * 构造函数
   */
  constructor(valueAccessor) {
    /**
     * 值访问器
     */
    __publicField(this, "valueAccessor");
    /**
     * 是否必填
     */
    __publicField(this, "required", false);
    /**
     * 是否只读
     */
    __publicField(this, "readonly", false);
    this.valueAccessor = valueAccessor;
  }
  /**
   * 获取控件值
   */
  get value() {
    return this.valueAccessor.getValue();
  }
  /**
   * 设置控件值
   */
  set value(value) {
    this.valueAccessor.setValue(value);
  }
}
class FormBuilder {
  /**
   * 构造函数
   */
  constructor(viewModel) {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 值访问器工厂
     */
    __publicField(this, "valueAccessorFactory");
    this.viewModel = viewModel;
    this.valueAccessorFactory = new ValueAccessorFactory(viewModel);
  }
  /**
   * 构造表单控件
   */
  buildFormControl(controlConfig) {
    const valueAccessor = this.valueAccessorFactory.create(controlConfig);
    const control = new FormControl(valueAccessor);
    return control;
  }
}
var FormChangeType = /* @__PURE__ */ ((FormChangeType2) => {
  FormChangeType2["ValueChange"] = "ValueChange";
  return FormChangeType2;
})(FormChangeType || {});
class FormInitializer {
  /**
   * 构造函数
   */
  constructor(form, formBuilder, viewModel) {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 表单
     */
    __publicField(this, "form");
    /**
     * 表单构造器
     */
    __publicField(this, "formBuilder");
    this.viewModel = viewModel;
    this.form = form;
    this.formBuilder = formBuilder;
  }
  /**
   * 初始化
   */
  init() {
    this.initFormControls();
    this.watchEntityStateChange();
  }
  /**
   * 包装带元数据的属性
   */
  initFormControls() {
    const propsMetas = PropMetadataReader.getPropsMetasByName(this.form.constructor, CONTROL_PROP_META_NAME);
    const form = this.form;
    Object.keys(propsMetas).forEach((propName) => {
      const controlMeta = propsMetas[propName];
      const controlConfig = this.convertMetaToConfig(propName, controlMeta);
      const control = this.formBuilder.buildFormControl(controlConfig);
      form.addControl(control);
      form[propName] = control;
    });
  }
  /**
   * 将控件属性元数据转换为配置
   */
  convertMetaToConfig(controlName, controlMeta) {
    const constrolSchema = {
      name: controlName,
      bindingType: controlMeta.bindingType,
      bindingPath: controlMeta.bindingPath
    };
    return constrolSchema;
  }
  /**
   * 监听实体变化变化
   */
  watchEntityStateChange() {
    if (!this.viewModel.entityState) {
      return;
    }
    this.viewModel.entityState.watchChanges(() => {
      const formChange = {
        type: FormChangeType.ValueChange
      };
      this.form.triggerChanges(formChange);
    });
  }
}
class Form {
  /**
   * 构造函数
   */
  constructor(viewModel) {
    /**
     * 副作用管理器
     */
    __publicField(this, "effectManager");
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 表单控件集合
     */
    __publicField(this, "controls");
    this.viewModel = viewModel;
    this.controls = [];
    this.effectManager = new EffectManager();
  }
  /**
   * 初始化
   */
  init() {
    const form = this;
    const formBuilder = new FormBuilder(this.viewModel);
    const initializer = new FormInitializer(form, formBuilder, this.viewModel);
    initializer.init();
  }
  /**
   * 添加控件
   */
  addControl(control) {
    this.controls.push(control);
  }
  /**
   * 删除控件
   */
  removeControl(control) {
    throw new Error("Not implemented");
  }
  /**
   * 触发变更
   */
  triggerChanges(change) {
    this.effectManager.trigger(change);
  }
  /**
   * 监听变更
   */
  watchChanges(changeEffectFunc) {
    const changeEffect = new Effect(changeEffectFunc);
    this.effectManager.addEffect(changeEffect);
    const stopWatch = () => {
      this.effectManager.removeEffect(changeEffect);
    };
    return stopWatch;
  }
}
const SM_STATE_PROP_META_NAME = "SM_STATE_PROP_META_NAME";
const smStatePropMetaFactory = (meta) => {
  return meta;
};
const SmStateProp = makePropMetadataDecorator(SM_STATE_PROP_META_NAME, smStatePropMetaFactory);
const SM_RENDER_STATE_PROP_META_NAME = "SM_RENDER_STATE_PROP_META_NAME";
const smRenderStatePropMetaFactory = (meta) => {
  return meta;
};
const SmRenderStateProp = makePropMetadataDecorator(SM_RENDER_STATE_PROP_META_NAME, smRenderStatePropMetaFactory);
const SM_ACTION_METHOD_META_NAME = "SM_ACTION_METHOD_META_NAME";
const smActionMethodMetaFactory = (meta) => {
  return meta;
};
const SmActionMethod = makePropMetadataDecorator(SM_ACTION_METHOD_META_NAME, smActionMethodMetaFactory);
var StateMachineChangeType = /* @__PURE__ */ ((StateMachineChangeType2) => {
  StateMachineChangeType2["StateChange"] = "StateChange";
  return StateMachineChangeType2;
})(StateMachineChangeType || {});
class StateMachineContext {
  /**
   * 构造函数
   */
  constructor(stateMachine, viewModel) {
    /**
     * 状态机
     */
    __publicField(this, "stateMachine");
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    this.stateMachine = stateMachine;
    this.viewModel = viewModel;
  }
  /**
   * 获取状态机当前状态
   */
  getCurrentSmState() {
    return this.stateMachine.currentState;
  }
  /**
   * 获取UI状态
   */
  getUIState(path) {
    const uiState = this.viewModel.uiState;
    if (!uiState) {
      throw new Error("UIState not existed when parsing uiState in StateMachine");
    }
    return uiState.getValueByPath(path);
  }
  /**
   * 获取实体状态
   */
  getEntityState(path) {
    const entityState = this.viewModel.entityState;
    if (!entityState) {
      throw new Error("EntityState not existed  when parsing uiState in StateMachine");
    }
    return entityState.getValueByPath(path);
  }
}
class StateMachineInitializer {
  /**
   * 构造函数
   */
  constructor(stateMachine) {
    /**
     * 状态机
     */
    __publicField(this, "stateMachine");
    this.stateMachine = stateMachine;
  }
  /**
   * 初始化属性
   */
  init() {
    this.initStateProps();
    this.initRenderStateProps();
    this.initActionProps();
  }
  /**
   * 初始化State属性
   */
  initStateProps() {
    const stateMetas = PropMetadataReader.getPropsMetasByName(
      this.stateMachine.constructor,
      SM_STATE_PROP_META_NAME
    );
    Object.keys(stateMetas).forEach((propName) => {
      this.stateMachine.states.set(propName, propName);
      const stateMeta = stateMetas[propName];
      if (stateMeta.isInit === true) {
        this.stateMachine.setCurrentState(propName);
      }
    });
  }
  /**
   * 初始化RenderState属性
   */
  initRenderStateProps() {
    const renderStateMetas = PropMetadataReader.getPropsMetasByName(
      this.stateMachine.constructor,
      SM_RENDER_STATE_PROP_META_NAME
    );
    Object.keys(renderStateMetas).forEach((propName) => {
      const renderStateMeta = renderStateMetas[propName];
      this.stateMachine.renderStates.set(propName, false);
      this.stateMachine[propName] = false;
      this.stateMachine.renders.set(propName, renderStateMeta.render);
    });
  }
  /**
   * 初始化Action属性
   */
  initActionProps() {
    const actionMetas = PropMetadataReader.getPropsMetasByName(
      this.stateMachine.constructor,
      SM_ACTION_METHOD_META_NAME
    );
    Object.keys(actionMetas).forEach((propName) => {
      const actionMeta = actionMetas[propName];
      this.stateMachine[propName] = () => {
        const nextState = actionMeta.transitionTo;
        if (this.stateMachine.states.has(nextState) === false) {
          throw new Error("State(${nextState}) does not exist");
        }
        this.stateMachine.transitTo(nextState);
      };
    });
  }
}
class StateMachine {
  /**
   * 构造函数
   */
  constructor(viewModel) {
    /**
     * 状态机上下文
     */
    __publicField(this, "context");
    /**
     * ViewModel上下文
     */
    __publicField(this, "viewModel");
    /**
     * 当前状态
     */
    __publicField(this, "currentState");
    /**
     * 状态字典
     */
    __publicField(this, "states");
    /**
     * 渲染状态字典
     */
    __publicField(this, "renderStates");
    /**
     * 渲染器字典
     */
    __publicField(this, "renders");
    /**
     * 变更副作用管理器
     */
    __publicField(this, "effectManager");
    this.viewModel = viewModel;
    this.context = new StateMachineContext(this, viewModel);
    this.states = /* @__PURE__ */ new Map();
    this.renderStates = /* @__PURE__ */ new Map();
    this.renders = /* @__PURE__ */ new Map();
    this.effectManager = new EffectManager();
  }
  /**
   * 初始化状态机
   */
  init() {
    const initializer = new StateMachineInitializer(this);
    initializer.init();
    this.render();
  }
  /**
   * 设置初始状态
   */
  setCurrentState(newState) {
    if (this.states.has(newState) === false) {
      throw new Error(`Can not transit to a state(${newState}) not existed`);
    }
    const oldState = this.currentState;
    if (oldState === newState) {
      return;
    }
    this.currentState = newState;
    this.render();
    const change = {
      type: StateMachineChangeType.StateChange,
      oldState,
      newState
    };
    this.triggerChange(change);
  }
  /**
   * 状态迁移
   */
  transitTo(newState) {
    this.setCurrentState(newState);
  }
  /**
   * 渲染全部可视化状态
   */
  render() {
    this.renderStates.forEach((renderState, renderStateName) => {
      const render = this.renders.get(renderStateName);
      if (!render) {
        throw new Error(`The render of renderState(${renderStateName}) does not exist`);
      }
      const renderStateValue = render(this.context);
      this[renderStateName] = renderStateValue;
      this.renderStates.set(renderStateName, renderStateValue);
    });
  }
  /**
   * 触发变更
   */
  triggerChange(change) {
    this.effectManager.trigger(change);
  }
  /**
   * 监听变更
   */
  watchChange(changeEffectFunc) {
    const changeEffect = new Effect(changeEffectFunc);
    this.effectManager.addEffect(changeEffect);
    const stopWatch = () => {
      this.effectManager.removeEffect(changeEffect);
    };
    return stopWatch;
  }
}
class Repository {
  /**
   * 构造函数
   */
  constructor(viewModel) {
    /**
     * 实体描述
     */
    __publicField(this, "entitySchema");
    /**
     * 实体类型
     */
    __publicField(this, "entityType");
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    this.viewModel = viewModel;
  }
  /**
   * 初始化
   */
  init() {
  }
  /**
   * 批量创建实体
   */
  buildEntites(entityDatas) {
    const entities = createEntitiesBySchema(this.entitySchema, entityDatas);
    return entities;
  }
  /**
   * 创建实体
   */
  buildEntity(entityData) {
    const entity = createEntityBySchema(this.entitySchema, entityData);
    return entity;
  }
}
const VARIABLE_PARSERS_TOKEN = createInjectionToken("@farris/devkit-vue VARIABLE_PARSERS");
class EntityStateVariableParser {
  /**
   * 解析变量
   * @summary
   * 表达式中可能多个变量，需要多次解析
   */
  parse(expression, context) {
    const entityState = this.getEntityState(context);
    const variablePaths = this.extractPaths(expression);
    if (variablePaths.length === 1 && expression === `{EntityState~${variablePaths[0]}}`) {
      return entityState.getValueByPath(variablePaths[0]);
    }
    variablePaths.forEach((variablePath) => {
      const searchValue = `{EntityState~${variablePath}}`;
      const replaceValue = entityState.getValueByPath(variablePath);
      expression = expression.replace(searchValue, replaceValue);
    });
    return expression;
  }
  /**
   * 获取实体状态
   */
  getEntityState(context) {
    if (!context || !context.viewModel || !context.viewModel.entityState) {
      throw new Error("The entityState can not be ");
    }
    return context.viewModel.entityState;
  }
  /**
   * 从表达式中提取变量
   */
  extractPaths(expression) {
    const variablePaths = [];
    const ENTITY_STATE_PATTERN_G = /\{EntityState~(\S+?)\}/g;
    const variables = expression.match(ENTITY_STATE_PATTERN_G);
    if (variables === null) {
      return [];
    }
    const ENTITY_STATE_PATTERN = /\{EntityState~(\S+?)\}/;
    variables.forEach((uiStateVariable) => {
      const pathMatches = uiStateVariable.match(ENTITY_STATE_PATTERN);
      if (pathMatches != null && pathMatches.length === 2) {
        variablePaths.push(pathMatches[1]);
      }
    });
    return variablePaths;
  }
}
class UIStateVariableParser {
  /**
   * 解析变量
   * @summary
   * 表达式中可能多个变量，需要多次解析
   */
  parse(expression, context) {
    const uiState = this.getUIState(context);
    const paths = this.extractPaths(expression);
    if (paths.length === 1 && expression === `{UIState~${paths[0]}}`) {
      return uiState.getValueByPath(paths[0]);
    }
    paths.forEach((path) => {
      const searchValue = `{UIState~${path}}`;
      const replaceValue = uiState.getValueByPath(path);
      expression = expression.replace(searchValue, replaceValue);
    });
    return expression;
  }
  /**
   * 获取实体状态
   */
  getUIState(context) {
    if (!context || !context.viewModel || !context.viewModel.uiState) {
      throw new Error("The uiState can not be empty ");
    }
    return context.viewModel.uiState;
  }
  /**
   * 从表达式中提取变量
   */
  extractPaths(expression) {
    const variablePaths = [];
    const UI_STATE_PATTERN_G = /\{UIState~(\S+?)\}/g;
    const variables = expression.match(UI_STATE_PATTERN_G);
    if (variables === null) {
      return [];
    }
    const UI_STATE_PATTERN = /\{UIState~(\S+?)\}/;
    variables.forEach((variable) => {
      const pathMatches = variable.match(UI_STATE_PATTERN);
      if (pathMatches != null && pathMatches.length === 2) {
        variablePaths.push(pathMatches[1]);
      }
    });
    return variablePaths;
  }
}
class CommandVariableParser {
  /**
   * 解析变量
   */
  parse(expression, context) {
    const commandContext = this.getCommandContext(context);
    const variablePaths = this.extractPaths(expression);
    if (variablePaths.length === 1 && expression === `{Command~${variablePaths[0]}}`) {
      return this.getValue(variablePaths[0], commandContext);
    }
    variablePaths.forEach((path) => {
      const searchValue = `{Command~${path}}`;
      const replaceValue = this.getValue(path, commandContext);
      expression = expression.replace(searchValue, replaceValue);
    });
    return expression;
  }
  /**
   * 获取上下文
   */
  getCommandContext(context) {
    if (!context || !context.extraContext) {
      throw new Error("The context can not be empty");
    }
    if (context.extraContext instanceof CommandContext === false) {
      throw new Error("The extendContext must be an instance of CommandContext");
    }
    return context.extraContext;
  }
  /**
   * 提取变量路径
   */
  extractPaths(expression) {
    const variablePaths = [];
    const COMMAND_PATTERN_G = /\{Command~(\S+?)\}/g;
    const variables = expression.match(COMMAND_PATTERN_G);
    if (variables === null) {
      return [];
    }
    const COMMAND_PATTERN = /\{Command~(\S+?)\}/;
    variables.forEach((variable) => {
      const pathMatches = variable.match(COMMAND_PATTERN);
      if (pathMatches != null && pathMatches.length === 2) {
        variablePaths.push(pathMatches[1]);
      }
    });
    return variablePaths;
  }
  /**
   * 获取变量值
   */
  getValue(path, commandContext) {
    const pathSegments = path.split("/").slice(1);
    const [type, name] = pathSegments;
    if (type === "params") {
      const params = commandContext.command.params;
      if (!params) {
        throw new Error("The params of command does not exist");
      }
      return params[name];
    } else if (type === "results") {
      const results = commandContext.results;
      return results[name];
    }
  }
}
class VariableParseService {
  /**
   * 构造函数
   */
  constructor(parsers) {
    /**
     * 解析器集合
     */
    __publicField(this, "parsers");
    this.parsers = parsers;
  }
  /**
   * 变量解析
   */
  parse(target, context) {
    if (typeof target === "string" && target.length > 0) {
      return this.parseExpression(target, context);
    } else if (Array.isArray(target)) {
      target.forEach((item, itemIndex) => {
        if (typeof item === "string") {
          target[itemIndex] = this.parseExpression(item, context);
        } else {
          target[itemIndex] = this.parse(item, context);
        }
      });
    } else if (typeof target === "object" && target !== null) {
      const keys = Object.keys(target);
      keys.forEach((key) => {
        if (typeof target[key] === "string") {
          target[key] = this.parseExpression(target[key], context);
        } else {
          target[key] = this.parse(target[key], context);
        }
      });
    }
    return target;
  }
  /**
   * 表达式求值
   */
  evaluate(expression, context) {
    const parsedExpression = this.parse(expression, context);
    return new Function("return " + parsedExpression)();
  }
  /**
   * 表达式解析
   */
  parseExpression(expression, context) {
    if (expression === "") {
      return "";
    }
    this.parsers.forEach((parser) => {
      if (typeof expression === "string") {
        expression = parser.parse(expression, context);
      }
    });
    return expression;
  }
}
const variableProviders = [
  { provide: VARIABLE_PARSERS_TOKEN, useClass: EntityStateVariableParser, multi: true, deps: [] },
  { provide: VARIABLE_PARSERS_TOKEN, useClass: UIStateVariableParser, multi: true, deps: [] },
  { provide: VARIABLE_PARSERS_TOKEN, useClass: CommandVariableParser, multi: true, deps: [] },
  { provide: VariableParseService, useClass: VariableParseService, deps: [VARIABLE_PARSERS_TOKEN] }
];
class CommandContext {
  constructor(command, viewModel) {
    /**
     * 命令实例
     */
    __publicField(this, "command");
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 执行结果
     */
    __publicField(this, "results", {});
    /**
     * 最新的执行结果
     */
    __publicField(this, "latestResult");
    /**
     * 事件参数
     */
    __publicField(this, "eventParams");
    this.command = command;
    this.viewModel = viewModel;
  }
}
class CommandHandler {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 变量解析服务
     */
    __publicField(this, "variableParseService");
  }
  /**
   * 初始化
   */
  init(viewModel) {
    this.viewModel = viewModel;
    this.variableParseService = viewModel.getInjector().get(VariableParseService);
  }
  /**
   * 调用方法
   */
  invoke(serviceInstance, methodName, originalArguments, commandContext) {
    this.setCommandContext(serviceInstance, commandContext);
    const variableParseContext = { viewModel: this.viewModel, extraContext: commandContext };
    const parsedArguments = this.variableParseService.parse(originalArguments, variableParseContext);
    return serviceInstance[methodName](...parsedArguments);
  }
  /**
   * 为服务设置命令上下文
   */
  setCommandContext(serviceInstance, context) {
    const serviceContext = serviceInstance.context;
    if (serviceContext && serviceContext instanceof CommandContext === false) {
      return;
    }
    serviceInstance.context = context;
  }
}
const COMMAND_HANDLERS_TOKEN = createInjectionToken("@Farris/devkit COMMAND_HANDLERS_TOKEN");
class CommandBus {
  constructor(injector, handlerFactory, variableParseService) {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    this.injector = injector;
    this.handlerFactory = handlerFactory;
    this.variableParseService = variableParseService;
    this.viewModel = this.injector.get(ViewModel);
  }
  /**
   * 派发命令
   */
  dispatch(command) {
    return this.executeCommand(command);
  }
  /**
   * 执行命令
   */
  async executeCommand(command) {
    const commandName = command.name;
    const handler = this.handlerFactory.create(commandName);
    const context = this.generateCommandContext(command);
    return handler.execute(context);
  }
  /**
   * 生成命令上下文
   */
  generateCommandContext(command) {
    const { eventParams = null } = command;
    const commandToExecute = { ...command };
    commandToExecute.eventParams = eventParams;
    const commandContext = new CommandContext(commandToExecute, this.viewModel);
    const variableParseContext = { viewModel: this.viewModel, extraContext: commandContext };
    commandToExecute.params = this.variableParseService.parse(commandToExecute.params, variableParseContext);
    commandContext.eventParams = command.eventParams || null;
    return commandContext;
  }
}
class CommandHandlerFactory {
  /**
   * 构造函数
   */
  constructor(injector, handlerRegistry) {
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    this.injector = injector;
    this.handlerRegistry = handlerRegistry;
    this.viewModel = this.injector.get(ViewModel);
  }
  /**
   * 创建命令处理器
   */
  create(commandName) {
    const handler = this.handlerRegistry.get(commandName);
    handler.init(this.viewModel);
    return handler;
  }
}
class CommandHandlerRegistry {
  /**
   * 构造函数
   */
  constructor(injector) {
    /**
     * 命令处理实例Map
     */
    __publicField(this, "handlerMap");
    this.injector = injector;
    this.init();
  }
  /**
   * 初始化
   */
  init() {
    const handlers = this.injector.get(COMMAND_HANDLERS_TOKEN, null, InjectFlags.Optional);
    this.handlerMap = /* @__PURE__ */ new Map();
    if (handlers) {
      handlers.forEach((handler) => {
        this.register(handler);
      });
    }
  }
  /**
   * 添加命令处理
   * @param  commandName    命令名称
   * @param  commandHandler 命令处理实例
   */
  set(commandName, commandHandler) {
    if (this.handlerMap.has(commandName)) {
      throw new Error(commandName + "’CommandHandler already exists");
    }
    this.handlerMap.set(commandName, commandHandler);
  }
  /**
   * 获取命令处理
   * @param   commandName 命令名称
   * @returns 命令处理实例
   */
  get(commandName) {
    if (!this.handlerMap.has(commandName)) {
      throw new Error("Unable to find the corresponding CommandHandler for" + commandName);
    }
    return this.handlerMap.get(commandName);
  }
  /**
   * 注册命令处理
   * @param handlers 命令处理实例
   */
  register(commandHandler) {
    const commandName = commandHandler.name;
    this.set(commandName, commandHandler);
  }
}
const commandProviders = [
  {
    provide: CommandHandlerRegistry,
    useClass: CommandHandlerRegistry,
    deps: [Injector]
  },
  {
    provide: CommandHandlerFactory,
    useClass: CommandHandlerFactory,
    deps: [Injector, CommandHandlerRegistry]
  },
  {
    provide: CommandBus,
    useClass: CommandBus,
    deps: [Injector, CommandHandlerFactory, VariableParseService]
  }
];
class ViewModelInitializer {
  /**
   * 初始化视图模型
   */
  constructor(viewModel) {
    /**
     * 副作用上下文
     */
    __publicField(this, "scope");
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 注入器
     */
    __publicField(this, "injector");
    /**
     * 属性包装器工厂
     */
    __publicField(this, "propWrapperFactory");
    /**
     * 属性包装器集合
     */
    __publicField(this, "propWrappers");
    this.viewModel = viewModel;
    this.injector = viewModel.getInjector();
    this.scope = effectScope(true);
    this.propWrapperFactory = new PropWrapperFactory();
    this.propWrappers = [];
  }
  /**
   * 初始化
   */
  init() {
    this.initEntityState();
    this.initUIState();
    this.initForm();
    this.initStateMachine();
    this.initRepository();
    this.initCommandBus();
    this.initPropWithMetas();
  }
  /**
   * 初始化实体状态
   */
  initEntityState() {
    const entityState = this.injector.get(EntityState, null);
    this.viewModel.entityState = entityState;
  }
  /**
   * 初始化UI状态
   */
  initUIState() {
    const uiState = this.injector.get(UIState, null);
    this.viewModel.uiState = uiState;
  }
  /**
   * 初始化表单
   */
  initForm() {
    const form = this.injector.get(Form, null);
    if (form) {
      form.init();
    }
    this.viewModel.form = form;
  }
  /**
   * 初始化状态机
   */
  initStateMachine() {
    const stateMachine = this.injector.get(StateMachine, null);
    if (stateMachine) {
      stateMachine.init();
    }
    this.viewModel.stateMachine = stateMachine;
  }
  /**
   * 初始化实体仓库
   */
  initRepository() {
    const repository = this.injector.get(Repository, null);
    if (repository) {
      repository.init();
    }
    this.viewModel.respository = repository;
  }
  /**
   * 初始化命令
   */
  initCommandBus() {
    const commandBus = this.injector.get(CommandBus, null);
    this.viewModel.commandBus = commandBus;
  }
  /**
   * 包装带元数据的属性
   */
  initPropWithMetas() {
    const propsMetas = PropMetadataReader.getPropsMetas(this.viewModel.constructor);
    Object.keys(propsMetas).forEach((propName) => {
      const propMetas = propsMetas[propName];
      propMetas.forEach((propMeta) => {
        const wrapper = this.propWrapperFactory.create(this.viewModel, propName, propMeta, this.scope);
        wrapper.wrap();
        this.propWrappers.push(wrapper);
      });
    });
  }
  /**
   * 注销
   */
  dispose() {
    this.scope.stop();
  }
}
class ViewModelNode {
  /**
   * 构造函数
   */
  constructor(injector) {
    /**
     * 注入器
     */
    __publicField(this, "injector");
    /**
     * 应用
     */
    __publicField(this, "app");
    /**
     * 根节点
     */
    __publicField(this, "root");
    /**
     * 父节点
     */
    __publicField(this, "parent");
    /**
     * 子节点集合
     */
    __publicField(this, "children");
    /**
     * 唯一标识
     */
    __publicField(this, "id");
    this.injector = injector;
    this.registerToApp();
    this.registerToParent();
  }
  /**
   * 注册到App
   */
  registerToApp() {
    this.app = this.injector.get(App);
    if (!this.app) {
      throw new Error("App not existed");
    }
    this.app.addViewModel(this);
  }
  /**
   * 从App中移除注册
   */
  unregisterFromApp() {
    this.app.removeViewModel(this);
  }
  /**
   * 注册父上下文
   */
  registerToParent() {
    const parentInjector = this.injector.get(Injector, null, InjectFlags.SkipSelf);
    if (!parentInjector) {
      this.parent = null;
      this.root = this;
      return;
    }
    const parent = parentInjector.get(ViewModelNode, null) || null;
    if (parent) {
      this.parent = parent;
      this.root = this.parent.root;
      parent.addChildNode(this);
    } else {
      this.parent = null;
      this.root = this;
    }
  }
  /**
   * 从Parent中移除注册
   */
  unregisterFromParent() {
    if (!this.parent) {
      return;
    }
    this.parent.removeChildNode(this);
  }
  /**
   * 注销上下文
   */
  dispose() {
    this.unregisterFromApp();
    this.unregisterFromParent();
  }
  /**
   * 获取注入器
   */
  getInjector() {
    return this.injector;
  }
  /**
   * 添加子节点
   */
  addChildNode(childNode) {
    if (!childNode) {
      return;
    }
    this.children.push(childNode);
  }
  /**
   * 删除子节点
   */
  removeChildNode(childNodeToRemove) {
    const index = this.children.findIndex((childNode) => {
      return childNode === childNodeToRemove;
    });
    if (index === -1) {
      return;
    }
    this.children.splice(index, 1);
  }
}
class ViewModel extends ViewModelNode {
  /**
   * 构造函数
   */
  constructor(injector) {
    super(injector);
    /**
     * 实体状态
     */
    __publicField(this, "entityState");
    /**
     * UI状态
     */
    __publicField(this, "uiState");
    /**
     * 表单
     */
    __publicField(this, "form");
    /**
     * 状态机
     */
    __publicField(this, "stateMachine");
    /**
     * 实体仓库
     */
    __publicField(this, "respository");
    /**
     * 命令总线
     */
    __publicField(this, "commandBus");
  }
  /**
   * 初始化
   */
  init() {
    const initializer = new ViewModelInitializer(this);
    initializer.init();
  }
  /**
   * 派发命令
   */
  dispatch(command) {
    if (!this.commandBus) {
      throw new Error("No CommandBus provided");
    }
    return this.commandBus.dispatch(command);
  }
  /**
   * 注销
   */
  dispose() {
    super.dispose();
  }
}
class HttpMethods {
}
__publicField(HttpMethods, "GET", "GET");
__publicField(HttpMethods, "DELETE", "DELETE");
__publicField(HttpMethods, "HEAD", "HEAD");
__publicField(HttpMethods, "OPTIONS", "OPTIONS");
__publicField(HttpMethods, "POST", "POST");
__publicField(HttpMethods, "PUT", "PUT");
__publicField(HttpMethods, "PATCH", "PATCH");
__publicField(HttpMethods, "LINK", "LINK");
__publicField(HttpMethods, "UNLINK", "UNLINK");
class HttpUtil {
  /**
   * 追加Header
   */
  static appendHeader(headers, key, value) {
    headers = Object.assign({}, headers, { [key]: value });
    return headers;
  }
  /**
   * 向RequestConfig中追加body
   */
  static appendBodyToRequestConfig(body, requestConfig) {
    if (!requestConfig) {
      requestConfig = {};
    }
    requestConfig = Object.assign({}, requestConfig, { body });
    return requestConfig;
  }
  /**
   * 构造AxiosReqeustConfig
   */
  static buildAxiosRequestConfig(method, url, requestConfig) {
    requestConfig = requestConfig || {};
    const axiosRequestConfig = {
      url,
      method,
      params: requestConfig.params || null,
      headers: requestConfig.headers || null,
      responseType: requestConfig.responseType || "json",
      data: requestConfig.body || null,
      withCredentials: true
    };
    return axiosRequestConfig;
  }
  /**
   * 构造Http响应信息
   */
  static buildHttpResponse(axiosResponse) {
    const httpResponse = {
      body: axiosResponse.data,
      headers: axiosResponse.headers,
      status: axiosResponse.status,
      statusText: axiosResponse.statusText
    };
    return httpResponse;
  }
}
class HttpClient {
  /**
   * 构造函数
   */
  constructor() {
    /**
     * axios实例
     */
    __publicField(this, "axiosInstance");
    this.axiosInstance = axios.create();
  }
  /**
   * 发送GET请求
   */
  get(url, requestConfig) {
    return this.request("GET", url, requestConfig);
  }
  /**
   * 发送POST请求
   */
  post(url, body, requestConfig) {
    requestConfig = HttpUtil.appendBodyToRequestConfig(body, requestConfig);
    return this.request("POST", url, requestConfig);
  }
  /**
   * 发送PUT请求
   */
  put(url, body, requestConfig) {
    requestConfig = HttpUtil.appendBodyToRequestConfig(body, requestConfig);
    return this.request("PUT", url, requestConfig);
  }
  /**
   * 发送PATCH请求
   */
  patch(url, body, requestConfig) {
    requestConfig = HttpUtil.appendBodyToRequestConfig(body, requestConfig);
    return this.request("PATCH", url, requestConfig);
  }
  /**
   * 发送DELETE请求
   */
  delete(url, requestConfig) {
    return this.request("DELETE", url, requestConfig);
  }
  /**
   * 发送请求
   */
  request(method, url, requestConfig) {
    const axiosRequestConfig = HttpUtil.buildAxiosRequestConfig(method, url, requestConfig);
    const responsePromise = this.axiosInstance.request(axiosRequestConfig).then((axiosResponse) => {
      const httpResponse = HttpUtil.buildHttpResponse(axiosResponse);
      return requestConfig.observe === "response" ? httpResponse : axiosResponse.data;
    });
    return responsePromise;
  }
}
const HTTP_PROVIDERS = [
  { provide: HttpClient, useClass: HttpClient, deps: [] }
];
function createViewModel(options) {
  const { parent } = options;
  if (!parent) {
    throw new Error("App injector not existed");
  }
  const parentInjector = parent.getInjector();
  const extraProviders = options.providers;
  const providers = [
    ...commandProviders,
    ...extraProviders,
    { provide: HttpClient, useClass: HttpClient, deps: [] },
    { provide: ViewModelNode, useExisting: ViewModel }
  ];
  const injector = createInjector(providers, parentInjector);
  const viewModel = injector.get(ViewModel);
  viewModel.init();
  return viewModel;
}
class App {
  /**
   * 构造函数
   */
  constructor(injector) {
    /**
     * 应用标识
     */
    __publicField(this, "id");
    /**
     * 注入器
     */
    __publicField(this, "injector");
    /**
     * 根视图模型集合
     */
    __publicField(this, "viewModels");
    /**
     * 参数
     */
    __publicField(this, "params", /* @__PURE__ */ new Map());
    this.injector = injector;
    this.viewModels = [];
    this.id = Token.create();
  }
  /**
   * 获取应用唯一标识
   */
  getId() {
    return this.id;
  }
  /**
   * 获取注入器
   */
  getInjector() {
    return this.injector;
  }
  /**
   * 添加子视图模型
   */
  addViewModel(viewModel) {
    this.viewModels.push(viewModel);
  }
  /**
   * 添加子视图模型
   */
  removeViewModel(viewModelToRemove) {
    const index = this.viewModels.findIndex((viewModel) => {
      return viewModel === viewModelToRemove;
    });
    if (index === -1) {
      return;
    }
    this.viewModels.splice(index, 1);
  }
  /**
   * 根据viewModel唯一标识获取对应的ViewModel
   * @param viewModelId viewModel唯一标识
   * @returns 
   */
  getViewModelById(viewModelId) {
    return this.viewModels.find((viewModel) => viewModel.id === viewModelId);
  }
  /**
   * 创建视图模型
   */
  createViewModel(viewModelOptions) {
    viewModelOptions.parent = viewModelOptions.parent || this;
    const viewModel = createViewModel(viewModelOptions);
    return viewModel;
  }
}
function createApp(options) {
  const extraProviders = Array.isArray(options.providers) ? options.providers : [];
  const providers = [
    { provide: App, useClass: App, deps: [Injector] },
    ...variableProviders,
    ...extraProviders
  ];
  const injector = createInjector(providers);
  const app = injector.get(App);
  return app;
}
const DEVKIT_APP = Symbol("DEVKIT_APP");
const DEVKIT_VIEW_MODEL = Symbol("DEVIT_VIEW_MODEL");
const DEVKIT_MAPPED_VIEW_MODEL = Symbol("DEVKIT_MAPPED_VIEW_MODEL");
function getApp() {
  const app = inject(DEVKIT_APP, null);
  if (!app) {
    throw new Error("App not existed");
  }
  return app;
}
function getViewModel() {
  const viewModel = inject(DEVKIT_VIEW_MODEL, null);
  return viewModel;
}
function getMappedViewModel() {
  const mappedViewModel = inject(DEVKIT_MAPPED_VIEW_MODEL, null);
  return mappedViewModel;
}
class EntityStateMapper {
  /**
   * 构造函数
   */
  constructor(entityState) {
    /**
     * 实体状态
     */
    __publicField(this, "entityState");
    /**
     * 响应式实体状态
     */
    __publicField(this, "entityStateRef");
    /**
     * 停止实体状态监听
     */
    __publicField(this, "stopEntityStateWatch");
    /**
     * 停止响应式对象监听
     */
    __publicField(this, "stopEntityStateRefWatch");
    this.entityState = entityState;
  }
  /**
   * 映射
   */
  map() {
    if (!this.entityState) {
      return null;
    }
    const rawEntityState = this.entityState.toJSON();
    this.entityStateRef = ref(rawEntityState);
    this.sync();
    return this.entityStateRef;
  }
  /**
   * 同步
   */
  sync() {
    this.stopEntityStateWatch = this.entityState.watchChanges((change) => {
      this.entityStateRef.value = this.entityState.toJSON();
    });
  }
  /**
   * 注销
   */
  dispose() {
    this.stopEntityStateWatch();
  }
}
class UIStateMapper {
  /**
   * 构造函数
   */
  constructor(uiState) {
    /**
     * UI状态
     */
    __publicField(this, "uiState");
    /**
     * 响应式UI状态
     */
    __publicField(this, "uiStateRef");
    /**
     * 停止UI状态变更监听
     */
    __publicField(this, "stopUIStateWatch");
    this.uiState = uiState;
  }
  /**
   * 映射
   */
  map() {
    if (!this.uiState) {
      return null;
    }
    this.uiStateRef = ref(this.uiState);
    this.sync();
    return this.uiStateRef;
  }
  /**
   * 同步
   */
  sync() {
    this.stopUIStateWatch = this.uiState.watchChange((change) => {
      triggerRef(this.uiStateRef);
    });
  }
  /**
   * 注销
   */
  dispose() {
    this.stopUIStateWatch();
  }
}
class FormMapper {
  /**
   * 构造函数
   */
  constructor(form) {
    /**
     * 实体状态
     */
    __publicField(this, "form");
    /**
     * 响应式实体状态
     */
    __publicField(this, "formRef");
    /**
     * 实体状态订阅
     */
    __publicField(this, "stopFormWatch");
    this.form = form;
  }
  /**
   * 映射
   */
  map() {
    if (!this.form) {
      return null;
    }
    this.formRef = ref(this.form);
    this.sync();
    return this.formRef;
  }
  /**
   * 同步
   */
  sync() {
    this.stopFormWatch = this.form.watchChanges((change) => {
      triggerRef(this.formRef);
    });
  }
  /**
   * 注销
   */
  dispose() {
    this.stopFormWatch();
  }
}
class StateMachineMapper {
  /**
   * 构造函数
   */
  constructor(stateMachine) {
    /**
     * 状态机实例
     */
    __publicField(this, "stateMachine");
    /**
     * 响应式状态机
     */
    __publicField(this, "stateMachineRef");
    /**
     * 停止状态机变更监听
     */
    __publicField(this, "stopStateMachineWatch");
    this.stateMachine = stateMachine;
  }
  /**
   * 映射
   */
  map() {
    if (!this.stateMachine) {
      return null;
    }
    this.stateMachineRef = ref(this.stateMachine);
    this.sync();
    return this.stateMachineRef;
  }
  /**
   * 同步
   */
  sync() {
    this.stopStateMachineWatch = this.stateMachine.watchChange((change) => {
      triggerRef(this.stateMachineRef);
    });
  }
  /**
   * 注销
   */
  dispose() {
    this.stopStateMachineWatch();
  }
}
class ViewModelMapper {
  /**
   * 构造函数
   */
  constructor(viewModel) {
    /**
     * 映射器集合
     */
    __publicField(this, "mappers");
    /**
     * 视图模型
     */
    __publicField(this, "viewModel");
    /**
     * 映射后的视图模型
     */
    __publicField(this, "mappedViewModel");
    this.viewModel = viewModel;
    this.mappedViewModel = {};
    this.initMappers();
  }
  /**
   * 映射
   */
  map() {
    this.mapStates();
    this.mapGetters();
    this.mapActions();
    this.mapCommandActions();
    this.mappers.forEach((mapper, key) => {
      this.mappedViewModel[key] = mapper.map();
    });
    this.mappedViewModel.injector = this.viewModel.getInjector();
    return reactive(this.mappedViewModel);
  }
  /**
   * 映射状态
   */
  mapStates() {
    const viewModel = this.viewModel;
    const statePropsMetas = PropMetadataReader.getPropsMetasByName(this.viewModel.constructor, STATE_PROP_META_NAME);
    Object.keys(statePropsMetas).forEach((propName) => {
      this.mappedViewModel[propName] = toRef(viewModel, propName);
    });
  }
  /**
   * 映射值访问器
   */
  mapGetters() {
    const viewModel = this.viewModel;
    const getterPropsMetas = PropMetadataReader.getPropsMetasByName(this.viewModel.constructor, GETTER_PROP_META_NAME);
    Object.keys(getterPropsMetas).forEach((propName) => {
      this.mappedViewModel[propName] = toRef(viewModel, propName);
    });
  }
  /**
   * 映射动作
   */
  mapActions() {
    const viewModel = this.viewModel;
    const actionPropsMetas = PropMetadataReader.getPropsMetasByName(this.viewModel.constructor, ACTION_PROP_META_NAME);
    Object.keys(actionPropsMetas).forEach((propName) => {
      this.mappedViewModel[propName] = viewModel[propName];
    });
  }
  /**
   * 映射命令
   */
  mapCommandActions() {
    const viewModel = this.viewModel;
    const commandPropsMetas = PropMetadataReader.getPropsMetasByName(this.viewModel.constructor, COMMAND_ACTION_PROP_META_NAME);
    Object.keys(commandPropsMetas).forEach((propName) => {
      this.mappedViewModel[propName] = viewModel[propName];
    });
  }
  /**
   * 注销
   */
  dispose() {
    this.mappers.forEach((mapper) => {
      mapper.dispose();
    });
  }
  /**
   * 创建映射器
   */
  initMappers() {
    this.mappers = /* @__PURE__ */ new Map();
    if (this.viewModel.entityState) {
      const entityStateMapper = new EntityStateMapper(this.viewModel.entityState);
      this.mappers.set("entityState", entityStateMapper);
    }
    if (this.viewModel.uiState) {
      const uiStateMapper = new UIStateMapper(this.viewModel.uiState);
      this.mappers.set("uiState", uiStateMapper);
    }
    if (this.viewModel.form) {
      const formMapper = new FormMapper(this.viewModel.form);
      this.mappers.set("form", formMapper);
    }
    if (this.viewModel.stateMachine) {
      const stateMachineMapper = new StateMachineMapper(this.viewModel.stateMachine);
      this.mappers.set("stateMachine", stateMachineMapper);
    }
  }
}
function useParentViewModel() {
  const parentViewModel = inject(DEVKIT_MAPPED_VIEW_MODEL, null);
  if (!parentViewModel) {
    throw new Error("Parent viewmodel not existed");
  }
  return parentViewModel;
}
function createProviders(options) {
  if (!options.viewModel) {
    throw new Error("ViewModel must be provided");
  }
  const providers = [
    { provide: ViewModel, useClass: options.viewModel, deps: [Injector] }
  ];
  if (options.repository) {
    providers.push({ provide: Repository, useClass: options.repository, deps: [ViewModel] });
  }
  if (options.entityState) {
    providers.push({ provide: EntityState, useClass: options.entityState, deps: [] });
  }
  if (options.uiState) {
    providers.push({ provide: UIState, useClass: options.uiState, deps: [] });
  }
  if (options.form) {
    providers.push({ provide: Form, useClass: options.form, deps: [ViewModel] });
  }
  if (options.stateMachine) {
    providers.push({ provide: StateMachine, useClass: options.stateMachine, deps: [ViewModel] });
  }
  if (Array.isArray(options.handlers)) {
    options.handlers.forEach((handlerType) => {
      providers.push({ provide: COMMAND_HANDLERS_TOKEN, useClass: handlerType, multi: true, deps: [] });
    });
  }
  const optionProviders = options.providers || [];
  const mergedProviders = [...providers, ...optionProviders];
  return mergedProviders;
}
function useViewModelMapper(viewModel) {
  const mapper = new ViewModelMapper(viewModel);
  const mappedViewModel = mapper.map();
  onUnmounted(() => {
    mapper.dispose();
  });
  return mappedViewModel;
}
function useViewModel(options) {
  const instance = getCurrentInstance();
  if (!instance) {
    return;
  }
  const app = getApp();
  const parentViewModel = getViewModel();
  const providers = createProviders(options);
  const viewModelOptions = {
    parent: parentViewModel,
    providers
  };
  const viewModel = app.createViewModel(viewModelOptions);
  provide(DEVKIT_VIEW_MODEL, viewModel);
  const mappedViewModel = useViewModelMapper(viewModel);
  provide(DEVKIT_MAPPED_VIEW_MODEL, mappedViewModel);
  onUnmounted(() => {
    viewModel.dispose();
  });
  return mappedViewModel;
}
function createDevkit(devkitOptions) {
  const devkit = {
    /**
     * 安装插件
     */
    install(app) {
      const devkitApp = createApp(devkitOptions);
      app.provide(DEVKIT_APP, devkitApp);
    }
  };
  return devkit;
}
export {
  ACTION_PROP_META_NAME,
  Action,
  App,
  BindingType,
  COMMAND_ACTION_PROP_META_NAME,
  COMMAND_HANDLERS_TOKEN,
  CONTROL_PROP_META_NAME,
  CommandAction,
  CommandBus,
  CommandContext,
  CommandHandler,
  CommandVariableParser,
  ControlProp,
  DEVKIT_APP,
  DEVKIT_MAPPED_VIEW_MODEL,
  DEVKIT_VIEW_MODEL,
  ENTITY_FIELD_META_NAME,
  ENTITY_LIST_FIELD_META_NAME,
  EXCEPTION_HANDLER_TOKEN,
  Effect,
  EffectManager,
  Entity,
  EntityChangeHistory,
  EntityChangeStatus,
  EntityChangeType,
  EntityField,
  EntityList,
  EntityListField,
  EntityNode,
  EntityPath,
  EntityPathBuilder,
  EntityPathNode,
  EntityPathNodeType,
  EntitySchema,
  EntityState,
  EntityStateMapper,
  EntityStateValueAccessor,
  EntityStateVariableParser,
  Field,
  FieldType,
  Form,
  FormChangeType,
  FormControl,
  FormMapper,
  GETTER_PROP_META_NAME,
  Getter,
  HTTP_PROVIDERS,
  HttpClient,
  HttpMethods,
  HttpUtil,
  INJECTOR,
  INJECTOR_IMPL,
  INJECTOR_IMPL__PRE_R3__,
  INJECTOR_SCOPE,
  InjectFlags,
  InjectionToken,
  Injector,
  OptionFlags,
  PRIMITIVE_FIELD_META_NAME,
  PropMetadataReader,
  PropWrapper,
  PropWrapperFactory,
  Repository,
  SM_ACTION_METHOD_META_NAME,
  SM_RENDER_STATE_PROP_META_NAME,
  SM_STATE_PROP_META_NAME,
  STATE_PROP_META_NAME,
  SmActionMethod,
  SmRenderStateProp,
  SmStateProp,
  State,
  StateMachine,
  StateMachineChangeType,
  StateMachineContext,
  StateMachineMapper,
  StaticInjector,
  Token,
  Type,
  UISTATE_PROP_META_NAME,
  UIState,
  UIStateChangeType,
  UIStateMapper,
  UIStateProp,
  UIStateValueAccessor,
  UIStateVariableParser,
  USE_VALUE,
  VARIABLE_PARSERS_TOKEN,
  ValueAccessorFactory,
  VariableParseService,
  ViewModel,
  ViewModelInitializer,
  ViewModelMapper,
  ViewModelNode,
  commandProviders,
  createApp,
  createDevkit,
  createEntities,
  createEntitiesBySchema,
  createEntity,
  createEntityBySchema,
  createEntityList,
  createEntityListBySchema,
  createEntitySchema,
  createInjectionToken,
  createInjector,
  createViewModel,
  entityFieldMetaFactory,
  entitylistFieldMetaFactory,
  getApp,
  getMappedViewModel,
  getViewModel,
  isType,
  makePropMetadataDecorator,
  makeTypeMetadataDecorator,
  primitiveFieldMetaFactory,
  setCurrentInjector,
  smActionMethodMetaFactory,
  smRenderStatePropMetaFactory,
  smStatePropMetaFactory,
  uiStatePropMetaFactory,
  useParentViewModel,
  useViewModel,
  variableProviders
};
