import { Injector } from '../common/di/index';
import { ViewModelOptions, ViewModelNode } from '../viewmodel/index';
/**
 * 应用
 */
declare class App {
    /**
     * 应用标识
     */
    private id;
    /**
     * 注入器
     */
    private injector;
    /**
     * 根视图模型集合
     */
    private viewModels;
    /**
     * 构造函数
     */
    constructor(injector: Injector);
    /**
     * 获取应用唯一标识
     */
    getId(): string;
    /**
     * 获取注入器
     */
    getInjector(): Injector;
    /**
     * 参数
     */
    params: Map<string, any>;
    /**
     * 添加子视图模型
     */
    addViewModel(viewModel: ViewModelNode): void;
    /**
     * 添加子视图模型
     */
    removeViewModel(viewModelToRemove: ViewModelNode): void;
    /**
     * 根据viewModel唯一标识获取对应的ViewModel
     * @param viewModelId viewModel唯一标识
     * @returns
     */
    getViewModelById(viewModelId: string): ViewModelNode;
    /**
     * 创建视图模型
     */
    createViewModel(viewModelOptions: ViewModelOptions): import("../viewmodel/viewmodel").ViewModel;
}
export { App };
