import { ViewModel } from '../viewmodel';
import { Command } from './command';
/**
 * 命令上下文
 */
declare class CommandContext {
    /**
     * 命令实例
     */
    command: Command;
    /**
     * 视图模型
     */
    viewModel: ViewModel;
    /**
     * 执行结果
     */
    results: {
        [taskName: string]: any;
    };
    /**
     * 最新的执行结果
     */
    latestResult: any;
    /**
     * 事件参数
     */
    eventParams: any;
    constructor(command: Command, viewModel: ViewModel);
}
export { CommandContext };
