import { Injector } from '../common';
import { CommandHandler } from './command-handler';
/**
 * 命令处理注册器
 */
declare class CommandHandlerRegistry {
    private injector;
    /**
     * 命令处理实例Map
     */
    private handlerMap;
    /**
     * 构造函数
     */
    constructor(injector: Injector);
    /**
     * 初始化
     */
    private init;
    /**
     * 添加命令处理
     * @param  commandName    命令名称
     * @param  commandHandler 命令处理实例
     */
    set(commandName: string, commandHandler: CommandHandler): void;
    /**
     * 获取命令处理
     * @param   commandName 命令名称
     * @returns 命令处理实例
     */
    get(commandName: string): CommandHandler;
    /**
     * 注册命令处理
     * @param handlers 命令处理实例
     */
    register(commandHandler: CommandHandler): void;
}
export { CommandHandlerRegistry };
