import { ViewModel } from '../viewmodel';
import { CommandContext } from './command-context';
/**
 * 命令处理抽象类
 */
declare abstract class CommandHandler {
    /**
     * 视图模型
     */
    private viewModel;
    /**
     * 变量解析服务
     */
    private variableParseService;
    /**
     * 命令执行
     */
    abstract execute(context: CommandContext): any;
    /**
     * 命令名称
     */
    abstract name: string;
    /**
     * 构造函数
     */
    constructor();
    /**
     * 初始化
     */
    init(viewModel: ViewModel): void;
    /**
     * 调用方法
     */
    invoke(serviceInstance: any, methodName: string, originalArguments: any[], commandContext: CommandContext): any;
    /**
     * 为服务设置命令上下文
     */
    private setCommandContext;
}
/**
 * 命令处理器注入Token
 */
declare const COMMAND_HANDLERS_TOKEN: import("../common").InjectionToken<any>;
export { CommandHandler, COMMAND_HANDLERS_TOKEN };
