/**
 * ----------------------------------------
 * Command相关定义
 * ----------------------------------------
 */
/**
 * 命令参数
 */
interface CommandParams {
    [key: string]: any;
}
/**
 * 参数描述
 */
interface ParamDescriptions {
    [key: string]: any;
}
/**
 * 命令接口
 */
interface Command {
    /**
     * 命令的名称，命令的唯一标识。
     */
    name: string;
    /**
     * 命令参数
     */
    params?: CommandParams;
    /**
     * 事件参数
     */
    eventParams?: any;
    /**
     * 参数描述
     */
    paramDescriptions?: ParamDescriptions;
}
export { CommandParams, ParamDescriptions, Command };
