import { Ref, UnwrapRef } from 'vue';
import { Entity, EntityState } from '../../entity/index';
import { Mapper } from './mapper';
/**
 * 实体状态映射器
 */
declare class EntityStateMapper implements Mapper {
    /**
     * 实体状态
     */
    private entityState;
    /**
     * 响应式实体状态
     */
    private entityStateRef;
    /**
     * 停止实体状态监听
     */
    private stopEntityStateWatch;
    /**
     * 停止响应式对象监听
     */
    private stopEntityStateRefWatch;
    /**
     * 构造函数
     */
    constructor(entityState: EntityState<Entity>);
    /**
     * 映射
     */
    map(): Ref<UnwrapRef<EntityState<Entity>>> | null;
    /**
     * 同步
     */
    private sync;
    /**
     * 注销
     */
    dispose(): void;
}
export { EntityStateMapper };
