import { Ref, UnwrapRef } from 'vue';
import { StateMachine } from '../../state-machine/index';
import { Mapper } from './mapper';
/**
 * 状态机映射器
 */
declare class StateMachineMapper implements Mapper {
    /**
     * 状态机实例
     */
    private stateMachine;
    /**
     * 响应式状态机
     */
    private stateMachineRef;
    /**
     * 停止状态机变更监听
     */
    private stopStateMachineWatch;
    /**
     * 构造函数
     */
    constructor(stateMachine: StateMachine);
    /**
     * 映射
     */
    map(): Ref<UnwrapRef<StateMachine>> | null;
    /**
     * 同步
     */
    private sync;
    /**
     * 注销
     */
    dispose(): void;
}
export { StateMachineMapper };
