import { Ref, UnwrapRef } from 'vue';
import { UIState } from '../../uistate/index';
import { Mapper } from './mapper';
/**
 * UI状态映射器
 */
declare class UIStateMapper implements Mapper {
    /**
     * UI状态
     */
    private uiState;
    /**
     * 响应式UI状态
     */
    private uiStateRef;
    /**
     * 停止UI状态变更监听
     */
    private stopUIStateWatch;
    /**
     * 构造函数
     */
    constructor(uiState: UIState);
    /**
     * 映射
     */
    map(): Ref<UnwrapRef<UIState>> | null;
    /**
     * 同步
     */
    private sync;
    /**
     * 注销
     */
    dispose(): void;
}
export { UIStateMapper };
