import { Type, StaticProvider } from '../common/index';
import { Repository } from '../repository/index';
import { Entity, EntityState } from '../entity/index';
import { UIState } from '../uistate/index';
import { Form } from '../form/index';
import { CommandHandler } from '../command/index';
import { ViewModel } from '../viewmodel/index';
import { StateMachine } from '../state-machine';
/**
 * 视图模型配置
 */
interface DevkitViewModelOptions {
    /**
     * 视图模型类型
     */
    viewModel: Type<ViewModel>;
    /**
     * 实体仓库
     */
    repository?: Type<Repository<Entity>>;
    /**
     * 实体状态
     */
    entityState?: Type<EntityState<Entity>>;
    /**
     * UI状态
     */
    uiState?: Type<UIState>;
    /**
     * UI状态
     */
    form?: Type<Form>;
    /**
     * 状态机
     */
    stateMachine?: Type<StateMachine>;
    /**
     * 命令处理器
     */
    handlers?: Type<CommandHandler>[];
    /**
     * 其他注入
     */
    providers?: StaticProvider[];
}
export { DevkitViewModelOptions };
