import { Type } from '../common/index';
import { EntitySchema } from './entity-schema/index';
import { Entity } from './entity';
/**
 * 创建实体（根据类型）
 */
declare function createEntity<T extends Entity>(entityType: Type<T>, entityData: any): T;
/**
 * 创建实体（根据描述）
 */
declare function createEntityBySchema<T extends Entity>(entitySchema: EntitySchema, entityData: any): T;
/**
 * 批量创建实体（根据类型）
 */
declare function createEntities<T extends Entity>(entityType: Type<T>, entityDatas: any[]): T[];
/**
 * 批量创建实体（根据描述）
 */
declare function createEntitiesBySchema<T extends Entity>(entitySchema: EntitySchema, entityDatas: any[]): T[];
export { createEntity, createEntities, createEntityBySchema, createEntitiesBySchema };
