import { Type, PropDecorator } from '../../common/index';
import { Entity } from '../../entity/index';
/**
 * 实体字段元数据
 */
interface EntityFieldMeta {
    /**
     * 字段名称
     */
    name?: string;
    /**
     * 实体类型
     */
    entityType: Type<Entity>;
}
/**
 * 实体字段元数据名称
 */
declare const ENTITY_FIELD_META_NAME = "ENTITY_FIELD";
/**
 * 实体字段元数据工厂方法
 */
declare const entityFieldMetaFactory: (meta: EntityFieldMeta) => EntityFieldMeta;
/**
 * 实体字段装饰器类型
 */
interface EntityFieldDecoratorFactory {
    (meta?: EntityFieldMeta): PropDecorator;
}
/**
 * 实体字段装饰器工厂
 */
declare const EntityField: EntityFieldDecoratorFactory;
export { EntityFieldMeta, ENTITY_FIELD_META_NAME, entityFieldMetaFactory, EntityFieldDecoratorFactory, EntityField };
