import { ViewModel } from '../viewmodel/index';
import { Form } from './form';
import { FormBuilder } from './form-builder';
/**
 * 初始化器
 */
declare class FormInitializer {
    /**
     * 视图模型
     */
    private viewModel;
    /**
     * 表单
     */
    private form;
    /**
     * 表单构造器
     */
    private formBuilder;
    /**
     * 构造函数
     */
    constructor(form: Form, formBuilder: FormBuilder, viewModel: ViewModel);
    /**
     * 初始化
     */
    init(): void;
    /**
     * 包装带元数据的属性
     */
    private initFormControls;
    /**
     * 将控件属性元数据转换为配置
     */
    private convertMetaToConfig;
    /**
     * 监听实体变化变化
     */
    watchEntityStateChange(): void;
}
export { FormInitializer };
