import { EffectManager } from '../common/index';
import { ViewModel } from "../viewmodel";
import { FormControl } from "./form-control";
import { FormChange } from './form-change';
/**
 * 表单
 */
declare abstract class Form {
    /**
     * 副作用管理器
     */
    effectManager: EffectManager<FormChange>;
    /**
     * 视图模型
     */
    private viewModel;
    /**
     * 表单控件集合
     */
    private controls;
    /**
     * 构造函数
     */
    constructor(viewModel: ViewModel);
    /**
     * 初始化
     */
    init(): void;
    /**
     * 添加控件
     */
    addControl(control: FormControl): void;
    /**
     * 删除控件
     */
    removeControl(control: FormControl): void;
    /**
     * 触发变更
     */
    triggerChanges(change: FormChange): void;
    /**
     * 监听变更
     */
    watchChanges(changeEffectFunc: (change: FormChange) => void): Function;
}
export { Form };
