import { PropDecorator } from '../../common/index';
import { BindingType } from "../types";
/**
 * 表单控件元数据
 */
interface ControlPropMeta {
    /**
     * 绑定字段路径
     */
    bindingType: BindingType;
    /**
     * 绑定路径
     */
    bindingPath: string;
}
/**
 * 表单控件元数据名称
 */
declare const CONTROL_PROP_META_NAME = "CONTROL";
/**
 * 表单控件装饰器类型
 */
interface ControlPropDecoratorFactory {
    (stateMeta?: ControlPropMeta): PropDecorator;
}
/**
 * 表单控件装饰器工厂
 */
declare const ControlProp: ControlPropDecoratorFactory;
export { ControlPropMeta, CONTROL_PROP_META_NAME, ControlPropDecoratorFactory, ControlProp };
