import { Type } from '../common/index';
import { Entity, EntitySchema } from '../entity/index';
import { ViewModel } from '../viewmodel/index';
/**
 * 实体仓库
 */
declare abstract class Repository<T extends Entity> {
    /**
     * 实体描述
     */
    protected entitySchema: EntitySchema;
    /**
     * 实体类型
     */
    entityType: Type<T>;
    /**
     * 视图模型
     */
    viewModel: ViewModel;
    /**
     * 构造函数
     */
    constructor(viewModel: ViewModel);
    /**
     * 初始化
     */
    init(): void;
    /**
     * 批量创建实体
     */
    buildEntites(entityDatas: any[]): T[];
    /**
     * 创建实体
     */
    buildEntity(entityData: any): T;
}
export { Repository };
