import { PropDecorator } from '../../common/index';
/**
 * 动作元数据类型
 */
interface SmActionMethodMeta {
    /**
     * 目标状态
     */
    transitionTo: string;
}
/**
 * 动作元数据名称
 */
declare const SM_ACTION_METHOD_META_NAME = "SM_ACTION_METHOD_META_NAME";
/**
 * 动作元数据工厂
 */
declare const smActionMethodMetaFactory: (meta: SmActionMethodMeta) => SmActionMethodMeta;
/**
 * 动作装饰器工厂类型
 */
interface SmActionMethodMetaDecoratorFactory {
    (meta?: SmActionMethodMeta): PropDecorator;
}
/**
 * 动作属性饰器工厂
 */
declare const SmActionMethod: SmActionMethodMetaDecoratorFactory;
export { SmActionMethodMeta, SM_ACTION_METHOD_META_NAME, smActionMethodMetaFactory, SmActionMethodMetaDecoratorFactory, SmActionMethod };
