import { PropDecorator } from '../../common/index';
import { SmRender } from '../types';
/**
 * 可视化状态元数据类型
 */
interface SmRenderStatePropMeta {
    /**
     * 渲染器
     */
    render: SmRender;
}
/**
 * 可视状态元数据名称
 */
declare const SM_RENDER_STATE_PROP_META_NAME = "SM_RENDER_STATE_PROP_META_NAME";
/**
 * 可视化状态元数据工厂
 */
declare const smRenderStatePropMetaFactory: (meta: SmRenderStatePropMeta) => SmRenderStatePropMeta;
/**
 * 可视化状态装饰器工厂类型
 */
interface SmRenderStatePropMetaDecoratorFactory {
    (meta?: SmRenderStatePropMeta): PropDecorator;
}
/**
 * 可视化状态饰器工厂
 */
declare const SmRenderStateProp: SmRenderStatePropMetaDecoratorFactory;
export { SmRenderStatePropMeta, SM_RENDER_STATE_PROP_META_NAME, smRenderStatePropMetaFactory, SmRenderStatePropMetaDecoratorFactory, SmRenderStateProp };
