import { PropDecorator } from '../../common/index';
/**
 * 状态元数据类型
 */
interface SmStatePropMeta {
    /**
     * 是否为初始状态
     */
    isInit?: boolean;
}
/**
 * 状态元数据名称
 */
declare const SM_STATE_PROP_META_NAME = "SM_STATE_PROP_META_NAME";
/**
 * 状态元数据工厂
 */
declare const smStatePropMetaFactory: (meta: SmStatePropMeta) => SmStatePropMeta;
/**
 * 状态装饰器工厂类型
 */
interface SmStatePropMetaDecoratorFactory {
    (meta?: SmStatePropMeta): PropDecorator;
}
/**
 * 状态饰器工厂
 */
declare const SmStateProp: SmStatePropMetaDecoratorFactory;
export { SmStatePropMeta, SM_STATE_PROP_META_NAME, smStatePropMetaFactory, SmStatePropMetaDecoratorFactory, SmStateProp };
