import { ViewModel } from '../viewmodel/index';
import { StateMachine } from './state-machine';
/**
 * 状态机上下文
 */
export declare class StateMachineContext {
    /**
     * 状态机
     */
    private stateMachine;
    /**
     * 视图模型
     */
    viewModel: ViewModel;
    /**
     * 构造函数
     */
    constructor(stateMachine: StateMachine, viewModel: ViewModel);
    /**
     * 获取状态机当前状态
     */
    getCurrentSmState(): string;
    /**
     * 获取UI状态
     */
    getUIState(path: string): any;
    /**
     * 获取实体状态
     */
    getEntityState(path: string): any;
}
