/**
 * UIState变更类型
 */
export declare enum UIStateChangeType {
    /**
     * 值变更
     */
    ValueChange = "ValueChange"
}
/**
 * UIState变更
 */
export interface UIStateChange {
    /**
     * 变更类型
     */
    type: UIStateChangeType;
    /**
     * 变更路径
     */
    path: string;
}
/**
 * UIState值变更
 */
export interface UIStateValueChange extends UIStateChange {
    /**
     * 变更类型
     */
    type: UIStateChangeType.ValueChange;
    /**
     * 旧值
     */
    oldValue: any;
    /**
     * 新值
     */
    newValue: any;
}
