import { PropDecorator } from '../../common/index';
/**
 * UI属性元数据
 */
interface UIStatePropMeta {
    /**
     * 属性名称
     */
    name?: string;
}
/**
 * UI属性元数据名称
 */
declare const UISTATE_PROP_META_NAME = "UISTATE_PROP_META";
/**
 * UI属性工厂方法
 */
declare const uiStatePropMetaFactory: (meta: UIStatePropMeta) => UIStatePropMeta;
/**
 * UI属性装饰器类型
 */
interface UIStatePropMetaDecoratorFactory {
    (meta?: UIStatePropMeta): PropDecorator;
}
/**
 * UI属性饰器工厂
 */
declare const UIStateProp: UIStatePropMetaDecoratorFactory;
export { UIStatePropMeta, UISTATE_PROP_META_NAME, uiStatePropMetaFactory, UIStatePropMetaDecoratorFactory, UIStateProp };
