import { UIStateChange } from './change/index';
/**
 * UI状态
 */
declare abstract class UIState {
    /**
     * 变更副作用管理器
     */
    private effectManager;
    /**
     * 构造函数
     */
    constructor();
    /**
     * 根据名称获取状态值
     */
    getValue(name: string): void;
    /**
     * 根据路径获取状态值
     */
    getValueByPath(path: string): any;
    /**
     * 检查路径合法性
     */
    private checkPath;
    /**
     * 设置属性值
     */
    setValue(name: string, newValue: any): void;
    /**
     * 触发变更
     */
    triggerChange(change: UIStateChange): void;
    /**
     * 监听变更
     */
    watchChange(changeEffectFunc: (change: UIStateChange) => void): () => void;
}
export { UIState };
