import { VariableParseContext, VariableParser } from './types';
/**
 * EntityState变量解析
 * @summary
 * 变量格式形如：
 * 1、简单字段：{EntityState~/id}
 * 2、关联字段：{EntityState~/departmentInfo/id}
 * 3、从表简单字段：{EntityState~/eduInfos/id}
 * 4、从表关联字段：{EntityState~/eduInfos/schoolInfo/id}
 */
declare class EntityStateVariableParser implements VariableParser {
    /**
     * 解析变量
     * @summary
     * 表达式中可能多个变量，需要多次解析
     */
    parse(expression: string, context: VariableParseContext): any;
    /**
     * 获取实体状态
     */
    private getEntityState;
    /**
     * 从表达式中提取变量
     */
    private extractPaths;
}
export { EntityStateVariableParser };
