import { VariableParseContext, VariableParser } from './types';
/**
 * UIState变量解析
 * @summary
 * 变量的格式如下：
 * 1、简单变量：{UIState~/currentTab}
 * 2、嵌套变量：{UIState~/filterState/keyword}
 * 3、其他变量：暂不支持嵌套数组的变量表达式
 */
declare class UIStateVariableParser implements VariableParser {
    /**
     * 解析变量
     * @summary
     * 表达式中可能多个变量，需要多次解析
     */
    parse(expression: string, context: VariableParseContext): any;
    /**
     * 获取实体状态
     */
    private getUIState;
    /**
     * 从表达式中提取变量
     */
    private extractPaths;
}
export { UIStateVariableParser };
