import { EffectScope } from 'vue';
import { ViewModel } from '../viewmodel';
/**
 * 属性包装器
 * @todo 抽象为属性扩展公共机制
 */
declare abstract class PropWrapper {
    /**
     * 视图模型
     */
    protected viewModel: ViewModel;
    /**
     * 属性名车给你
     */
    protected propName: string;
    /**
     * 属性元数据
     */
    protected propMeta: any;
    /**
     * 副作用上下文
     */
    protected scope: EffectScope;
    /**
     * 构造函数
     */
    constructor(viewModel: ViewModel, propName: string, propMeta: any, scope: EffectScope);
    /**
     * 包装属性
     */
    abstract wrap(): void;
    /**
     * 注销
     */
    abstract dispose(): void;
}
export { PropWrapper };
