import { EffectScope } from 'vue';
import { PropWrapper } from './prop-wrapper';
import { ViewModel } from '../viewmodel';
/**
 * 状态属性包装器
 */
declare class StatePropWrapper extends PropWrapper {
    /**
     * 构造函数
     */
    constructor(viewModel: ViewModel, propName: string, propMeta: any, scope: EffectScope);
    /**
     * 包装属性
     * @summary
     * 将状态属性包装为ref，并自动解包
     */
    wrap(): void;
    /**
     * 注销
     */
    dispose(): void;
}
export { StatePropWrapper };
