import { ViewModel } from './viewmodel';
/**
 * 视图模型初始化器
 */
declare class ViewModelInitializer {
    /**
     * 副作用上下文
     */
    private scope;
    /**
     * 视图模型
     */
    private viewModel;
    /**
     * 注入器
     */
    private injector;
    /**
     * 属性包装器工厂
     */
    private propWrapperFactory;
    /**
     * 属性包装器集合
     */
    private propWrappers;
    /**
     * 初始化视图模型
     */
    constructor(viewModel: ViewModel);
    /**
     * 初始化
     */
    init(): void;
    /**
     * 初始化实体状态
     */
    private initEntityState;
    /**
     * 初始化UI状态
     */
    private initUIState;
    /**
     * 初始化表单
     */
    private initForm;
    /**
     * 初始化状态机
     */
    private initStateMachine;
    /**
     * 初始化实体仓库
     */
    private initRepository;
    /**
     * 初始化命令
     */
    private initCommandBus;
    /**
     * 包装带元数据的属性
     */
    private initPropWithMetas;
    /**
     * 注销
     */
    dispose(): void;
}
export { ViewModelInitializer };
